xref: /illumos-gate/usr/src/tools/scripts/nightly (revision cdf0c1d5)
1#!/bin/ksh -p
2#
3# CDDL HEADER START
4#
5# The contents of this file are subject to the terms of the
6# Common Development and Distribution License (the "License").
7# You may not use this file except in compliance with the License.
8#
9# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
10# or http://www.opensolaris.org/os/licensing.
11# See the License for the specific language governing permissions
12# and limitations under the License.
13#
14# When distributing Covered Code, include this CDDL HEADER in each
15# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
16# If applicable, add the following below this CDDL HEADER, with the
17# fields enclosed by brackets "[]" replaced with your own identifying
18# information: Portions Copyright [yyyy] [name of copyright owner]
19#
20# CDDL HEADER END
21#
22
23#
24# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
25# Use is subject to license terms.
26#
27# ident	"%Z%%M%	%I%	%E% SMI"
28#
29# Based on the nightly script from the integration folks,
30# Mostly modified and owned by mike_s.
31# Changes also by kjc, dmk.
32#
33# BRINGOVER_WS may be specified in the env file.
34# The default is the old behavior of CLONE_WS
35#
36# -i on the command line, means fast options, so when it's on the
37# command line (only), lint and check builds are skipped no matter what
38# the setting of their individual flags are in NIGHTLY_OPTIONS.
39#
40# LINTDIRS can be set in the env file, format is a list of:
41#
42#	/dirname-to-run-lint-on flag
43#
44#	Where flag is:	y - enable lint noise diff output
45#			n - disable lint noise diff output
46#
47#	For example: LINTDIRS="$SRC/uts n $SRC/stand y $SRC/psm y"
48#
49# -A flag in NIGHTLY_OPTIONS checks ABI diffs in .so files
50# This option requires a couple of scripts.
51#
52# OPTHOME and TEAMWARE may be set in the environment to override /opt
53# and /opt/teamware defaults.
54#
55
56#
57# The CDPATH variable causes ksh's `cd' builtin to emit messages to stdout
58# under certain circumstances, which can really screw things up; unset it.
59#
60unset CDPATH
61
62# Get the absolute path of the nightly script that the user invoked.  This
63# may be a relative path, and we need to do this before changing directory.
64nightly_path=`whence $0`
65
66#
67# Keep track of where we found nightly so we can invoke the matching
68# which_scm script.  If that doesn't work, don't go guessing, just rely
69# on the $PATH settings, which will generally give us either /opt/onbld
70# or the user's workspace.
71#
72WHICH_SCM=$(dirname $nightly_path)/which_scm
73if [[ ! -x $WHICH_SCM ]]; then
74	WHICH_SCM=which_scm
75fi
76
77#
78# Print the tag string used to identify a build (e.g., "DEBUG
79# open-only")
80# usage: tagstring debug-part open-part
81#
82tagstring() {
83	debug_part=$1
84	open_part=$2
85
86	if [ -n "$open_part" ]; then
87		echo "$debug_part $open_part"
88	else
89		echo "$debug_part"
90	fi
91}
92
93#
94# Function to do a DEBUG and non-DEBUG build. Needed because we might
95# need to do another for the source build, and since we only deliver DEBUG or
96# non-DEBUG packages.
97#
98# usage: normal_build [-O]
99# -O	OpenSolaris delivery build.  Put the proto area and
100#	(eventually) packages in -open directories.  Use skeleton
101#	closed binaries.  Don't generate archives--that needs to be
102#	done later, after we've generated the closed binaries.  Also
103#	skip the package build (until 6414822 is fixed).
104#
105
106normal_build() {
107
108	typeset orig_p_FLAG="$p_FLAG"
109	typeset orig_a_FLAG="$a_FLAG"
110
111	suffix=""
112	open_only=""
113	while getopts O FLAG $*; do
114		case $FLAG in
115		O)
116			suffix="-open"
117			open_only="open-only"
118			p_FLAG=n
119			a_FLAG=n
120			;;
121		esac
122	done
123
124	# non-DEBUG build begins
125
126	if [ "$F_FLAG" = "n" ]; then
127		set_non_debug_build_flags
128		mytag=`tagstring "non-DEBUG" "$open_only"`
129		build "$mytag" "$suffix-nd" "$MULTI_PROTO"
130		if [ "$build_ok" = "y" -a "$X_FLAG" = "y" -a \
131		    "$p_FLAG" = "y" ]; then
132			copy_ihv_pkgs non-DEBUG -nd
133		fi
134	else
135		echo "\n==== No non-DEBUG $open_only build ====\n" >> "$LOGFILE"
136	fi
137
138	# non-DEBUG build ends
139
140	# DEBUG build begins
141
142	if [ "$D_FLAG" = "y" ]; then
143		set_debug_build_flags
144		mytag=`tagstring "DEBUG" "$open_only"`
145		build "$mytag" "$suffix" "$MULTI_PROTO"
146		if [ "$build_ok" = "y" -a "$X_FLAG" = "y" -a \
147		    "$p_FLAG" = "y" ]; then
148			copy_ihv_pkgs DEBUG ""
149		fi
150
151	else
152		echo "\n==== No DEBUG $open_only build ====\n" >> "$LOGFILE"
153	fi
154
155	# DEBUG build ends
156
157	p_FLAG="$orig_p_FLAG"
158	a_FLAG="$orig_a_FLAG"
159}
160
161#
162# usage: run_hook HOOKNAME ARGS...
163#
164# If variable "$HOOKNAME" is defined, insert a section header into
165# our logs and then run the command with ARGS
166#
167run_hook() {
168	HOOKNAME=$1
169    	eval HOOKCMD=\$$HOOKNAME
170	shift
171
172	if [ -n "$HOOKCMD" ]; then
173	    	(
174			echo "\n==== Running $HOOKNAME command: $HOOKCMD ====\n"
175		    	( $HOOKCMD "$@" 2>&1 )
176			if [ "$?" -ne 0 ]; then
177			    	# Let exit status propagate up
178			    	touch $TMPDIR/abort
179			fi
180		) | tee -a $mail_msg_file >> $LOGFILE
181
182		if [ -f $TMPDIR/abort ]; then
183			build_ok=n
184			echo "\nAborting at request of $HOOKNAME" |
185				tee -a $mail_msg_file >> $LOGFILE
186			exit 1
187		fi
188	fi
189}
190
191#
192# usage: filelist DESTDIR PATTERN
193#
194filelist() {
195	DEST=$1
196	PATTERN=$2
197	cd ${DEST}
198
199	OBJFILES=${ORIG_SRC}/xmod/obj_files
200	if [ ! -f ${OBJFILES} ]; then
201		return;
202	fi
203	for i in `grep -v '^#' ${OBJFILES} | \
204	    grep ${PATTERN} | cut -d: -f2 | tr -d ' \t'`
205	do
206		# wildcard expansion
207		for j in $i
208		do
209			if [ -f "$j" ]; then
210				echo $j
211			fi
212			if [ -d "$j" ]; then
213				echo $j
214			fi
215		done
216	done | sort | uniq
217}
218
219# function to save off binaries after a full build for later
220# restoration
221save_binaries() {
222	# save off list of binaries
223	echo "\n==== Saving binaries from build at `date` ====\n" | \
224	    tee -a $mail_msg_file >> $LOGFILE
225	rm -f ${BINARCHIVE}
226	cd ${CODEMGR_WS}
227	filelist ${CODEMGR_WS} '^preserve:' >> $LOGFILE
228	filelist ${CODEMGR_WS} '^preserve:' | \
229	    cpio -ocB 2>/dev/null | compress \
230	    > ${BINARCHIVE}
231}
232
233# delete files
234# usage: hybridize_files DESTDIR MAKE_TARGET
235hybridize_files() {
236	DEST=$1
237	MAKETARG=$2
238
239	echo "\n==== Hybridizing files at `date` ====\n" | \
240	    tee -a $mail_msg_file >> $LOGFILE
241	for i in `filelist ${DEST} '^delete:'`
242	do
243		echo "removing ${i}." | tee -a $mail_msg_file >> $LOGFILE
244		rm -rf "${i}"
245	done
246	for i in `filelist ${DEST} '^hybridize:' `
247	do
248		echo "hybridizing ${i}." | tee -a $mail_msg_file >> $LOGFILE
249		rm -f ${i}+
250		sed -e "/^# HYBRID DELETE START/,/^# HYBRID DELETE END/d" \
251		    < ${i} > ${i}+
252		mv ${i}+ ${i}
253	done
254}
255
256# restore binaries into the proper source tree.
257# usage: restore_binaries DESTDIR MAKE_TARGET
258restore_binaries() {
259	DEST=$1
260	MAKETARG=$2
261
262	echo "\n==== Restoring binaries to ${MAKETARG} at `date` ====\n" | \
263	    tee -a $mail_msg_file >> $LOGFILE
264	cd ${DEST}
265	zcat ${BINARCHIVE} | \
266	    cpio -idmucvB 2>/dev/null | tee -a $mail_msg_file >> ${LOGFILE}
267}
268
269# rename files we save binaries of
270# usage: rename_files DESTDIR MAKE_TARGET
271rename_files() {
272	DEST=$1
273	MAKETARG=$2
274	echo "\n==== Renaming source files in ${MAKETARG} at `date` ====\n" | \
275	    tee -a $mail_msg_file >> $LOGFILE
276	for i in `filelist ${DEST} '^rename:'`
277	do
278		echo ${i} | tee -a $mail_msg_file >> ${LOGFILE}
279		rm -f ${i}.export
280		mv ${i} ${i}.export
281	done
282}
283
284#
285# Copy some or all of the source tree.
286#
287# Returns 0 for success, non-zero for failure.
288#
289# usage: copy_source CODEMGR_WS DESTDIR LABEL SRCROOT
290#
291copy_source() {
292	WS=$1
293	DEST=$2
294	label=$3
295	srcroot=$4
296
297	printf "\n==== Creating %s source from %s (%s) ====\n\n" \
298	    "$DEST" "$WS" "$label" | tee -a $mail_msg_file >> $LOGFILE
299
300	printf "cleaning out %s\n" "$DEST." >> $LOGFILE
301	rm -rf "$DEST" >> $LOGFILE 2>&1
302
303	printf "creating %s\n" "$DEST." >> $LOGFILE
304	mkdir -p "$DEST" 2>> $LOGFILE
305
306	if (( $? != 0 )) ; then
307		printf "failed to create %s\n" "$DEST" |
308		    tee -a $mail_msg_file >> $LOGFILE
309		build_ok=n
310		return 1
311	fi
312	cd "$WS"
313
314	printf "populating %s\n" "$DEST." >> $LOGFILE
315
316	case "$SCM_TYPE" in
317	teamware)
318		find $srcroot -name 's\.*' -a -type f -print | \
319		    sed -e 's,SCCS\/s.,,' | \
320		    grep -v '/\.del-*' | \
321		    cpio -pd $DEST >>$LOGFILE 2>&1
322		if (( $? != 0 )) ; then
323		    printf "cpio failed for %s\n" "$DEST" |
324			tee -a $mail_msg_file >> $LOGFILE
325		    build_ok=n
326		    return 1
327		fi
328		;;
329	mercurial)
330		copy_source_mercurial $DEST $srcroot
331		if (( $? != 0 )) ; then
332		    build_ok=n
333		    return 1
334		fi
335		;;
336	*)
337		build_ok=n
338		echo "Tree copy is not supported for workspace type" \
339		    "$SCM_TYPE" | tee -a $mail_msg_file >> $LOGFILE
340		return 1
341		;;
342	esac
343
344	return 0
345}
346
347#
348# Mercurial-specific copy code for copy_source().  Handles the
349# combined open and closed trees.
350#
351# Returns 0 for success, non-zero for failure.
352#
353# usage: copy_source_mercurial destdir srcroot
354#
355function copy_source_mercurial {
356	typeset dest=$1
357	typeset srcroot=$2
358	typeset open_top closed_top
359
360	case $srcroot in
361	usr)
362		open_top=usr
363		if [[ "$CLOSED_IS_PRESENT" = yes ]]; then
364			closed_top=usr/closed
365		fi
366		;;
367	usr/closed*)
368		if [[ "$CLOSED_IS_PRESENT" = no ]]; then
369			printf "can't copy %s: closed tree not present.\n" \
370			    "$srcroot" | tee -a $mail_msg_file >> $LOGFILE
371			return 1
372		fi
373		closed_top="$srcroot"
374		;;
375	*)
376		open_top="$srcroot"
377		;;
378	esac
379
380	if [[ -n "$open_top" ]]; then
381		hg locate -I "$open_top" | cpio -pd "$dest" >>$LOGFILE 2>&1
382		if (( $? != 0 )) ; then
383		    printf "cpio failed for %s\n" "$dest" |
384			tee -a $mail_msg_file >> $LOGFILE
385		    return 1
386		fi
387	fi
388
389	if [[ -n "$closed_top" ]]; then
390		mkdir -p "$dest/usr/closed" || return 1
391		if [[ "$closed_top" = usr/closed ]]; then
392			(cd usr/closed; hg locate |
393			    cpio -pd "$dest/usr/closed") >>$LOGFILE 2>&1
394			if (( $? != 0 )) ; then
395			    printf "cpio failed for %s/usr/closed\n" \
396				"$dest" | tee -a $mail_msg_file >> $LOGFILE
397			    return 1
398			fi
399		else
400			# copy subtree of usr/closed
401			closed_top=${closed_top#usr/closed/}
402			(cd usr/closed; hg locate -I "$closed_top" |
403			    cpio -pd "$dest/usr/closed") >>$LOGFILE 2>&1
404			if (( $? != 0 )) ; then
405			    printf "cpio failed for %s/usr/closed/%s\n" \
406				"$dest" "$closed_top" |
407				tee -a $mail_msg_file >> $LOGFILE
408			    return 1
409			fi
410		fi
411	fi
412
413	return 0
414}
415
416#
417# function to create (but not build) the export/crypt source tree.
418# usage: set_up_source_build CODEMGR_WS DESTDIR MAKE_TARGET
419# Sets SRC to the modified source tree, for use by the caller when it
420# builds the tree.
421#
422set_up_source_build() {
423	WS=$1
424	DEST=$2
425	MAKETARG=$3
426
427	copy_source $WS $DEST $MAKETARG usr
428	if (( $? != 0 )); then
429	    echo "\nCould not copy source tree for source build." |
430		tee -a $mail_msg_file >> $LOGFILE
431	    build_ok=n
432	    return
433	fi
434
435	SRC=${DEST}/usr/src
436
437	cd $SRC
438	rm -f ${MAKETARG}.out
439	echo "making ${MAKETARG} in ${SRC}." >> $LOGFILE
440	/bin/time $MAKE -e ${MAKETARG} 2>&1 | \
441	    tee -a $SRC/${MAKETARG}.out >> $LOGFILE
442	echo "\n==== ${MAKETARG} build errors ====\n" >> $mail_msg_file
443	egrep ":" $SRC/${MAKETARG}.out | \
444		egrep -e "(^${MAKE}:|[ 	]error[: 	\n])" | \
445		egrep -v "Ignoring unknown host" | \
446		egrep -v "warning" >> $mail_msg_file
447
448	echo "clearing state files." >> $LOGFILE
449	find . -name '.make*' -exec rm -f {} \;
450
451	cd ${DEST}
452	if [ "${MAKETARG}" = "CRYPT_SRC" ]; then
453		rm -f ${CODEMGR_WS}/crypt_files.cpio.Z
454		echo "\n==== xmod/cry_files that don't exist ====\n" | \
455		    tee -a $mail_msg_file >> $LOGFILE
456		CRYPT_FILES=${WS}/usr/src/xmod/cry_files
457		for i in `cat ${CRYPT_FILES}`
458		do
459			# make sure the files exist
460			if [ -f "$i" ]; then
461				continue
462			fi
463			if [ -d "$i" ]; then
464				continue
465			fi
466			echo "$i" | tee -a $mail_msg_file >> $LOGFILE
467		done
468		find `cat ${CRYPT_FILES}` -print 2>/dev/null | \
469		    cpio -ocB 2>/dev/null | \
470		    compress > ${CODEMGR_WS}/crypt_files.cpio.Z
471	fi
472
473	if [ "${MAKETARG}" = "EXPORT_SRC" ]; then
474		# rename first, since we might restore a file
475		# of the same name (mapfiles)
476		rename_files ${EXPORT_SRC} EXPORT_SRC
477		if [ "$SH_FLAG" = "y" ]; then
478			hybridize_files ${EXPORT_SRC} EXPORT_SRC
479		fi
480	fi
481
482	# save the cleartext
483	echo "\n==== Creating ${MAKETARG}.cpio.Z ====\n" | \
484	    tee -a $mail_msg_file >> $LOGFILE
485	cd ${DEST}
486	rm -f ${MAKETARG}.cpio.Z
487	find usr -depth -print | \
488	    grep -v usr/src/${MAKETARG}.out | \
489	    cpio -ocB 2>/dev/null | \
490	    compress > ${CODEMGR_WS}/${MAKETARG}.cpio.Z
491	if [ "${MAKETARG}" = "EXPORT_SRC" ]; then
492		restore_binaries ${EXPORT_SRC} EXPORT_SRC
493	fi
494
495	if [ "${MAKETARG}" = "CRYPT_SRC" ]; then
496		restore_binaries ${CRYPT_SRC} CRYPT_SRC
497	fi
498
499}
500
501# Return library search directive as function of given root.
502myldlibs() {
503	echo "-L$1/lib -L$1/usr/lib"
504}
505
506# Return header search directive as function of given root.
507myheaders() {
508	echo "-I$1/usr/include"
509}
510
511#
512# Wrapper over commands that generate BFU archives.  The entire
513# command output gets written to LOGFILE, and any unexpected messages
514# are written to the mail message.  Returns with the status of the
515# original command.
516#
517makebfu_filt() {
518	typeset tmplog
519	typeset errors
520	typeset cmd
521	integer cmd_stat
522
523	cmd="$1"
524	shift
525	tmplog="$TMPDIR/$cmd.out"
526	errors="$TMPDIR/$cmd-errors"
527	$cmd $* > "$tmplog" 2>&1
528	cmd_stat=$?
529	cat "$tmplog" >> "$LOGFILE"
530	grep -v "^Creating .* archive:" "$tmplog" | grep -v "^Making" | \
531	    grep -v "^$" | sort -u > "$errors"
532	if [[ -s "$errors" ]]; then
533		echo "\n==== cpio archives build errors ($LABEL) ====\n" \
534		    >> "$mail_msg_file"
535		cat "$errors" >> "$mail_msg_file"
536	fi
537	rm -f "$tmplog" "$errors"
538	return $cmd_stat
539}
540
541#
542# Function to do the build, including cpio archive and package generation.
543# usage: build LABEL SUFFIX MULTIPROTO
544# - LABEL is used to tag build output.
545# - SUFFIX is used to distinguish files (e.g., debug vs non-debug).
546# - If MULTIPROTO is "yes", it means to name the proto area according to
547#   SUFFIX.  Otherwise ("no"), (re)use the standard proto area.
548#
549build() {
550	LABEL=$1
551	SUFFIX=$2
552	MULTIPROTO=$3
553	INSTALLOG=install${SUFFIX}-${MACH}
554	NOISE=noise${SUFFIX}-${MACH}
555	CPIODIR=${CPIODIR_ORIG}${SUFFIX}
556	PKGARCHIVE=${PKGARCHIVE_ORIG}${SUFFIX}
557	if [ "$SPARC_RM_PKGARCHIVE_ORIG" ]; then
558		SPARC_RM_PKGARCHIVE=${SPARC_RM_PKGARCHIVE_ORIG}${SUFFIX}
559	fi
560
561	ORIGROOT=$ROOT
562	[ $MULTIPROTO = no ] || export ROOT=$ROOT$SUFFIX
563
564	export ENVLDLIBS1=`myldlibs $ROOT`
565	export ENVCPPFLAGS1=`myheaders $ROOT`
566
567	this_build_ok=y
568	#
569	#	Build OS-Networking source
570	#
571	echo "\n==== Building OS-Net source at `date` ($LABEL) ====\n" \
572		>> $LOGFILE
573
574	rm -f $SRC/${INSTALLOG}.out
575	cd $SRC
576	/bin/time $MAKE -e install 2>&1 | \
577	    tee -a $SRC/${INSTALLOG}.out >> $LOGFILE
578
579	if [[ "$SCM_TYPE" = teamware ]]; then
580		echo "\n==== SCCS Noise ($LABEL) ====\n" >> $mail_msg_file
581		egrep 'sccs(check:| *get)' $SRC/${INSTALLOG}.out >> \
582			$mail_msg_file
583	fi
584
585	echo "\n==== Build errors ($LABEL) ====\n" >> $mail_msg_file
586	egrep ":" $SRC/${INSTALLOG}.out |
587		egrep -e "(^${MAKE}:|[ 	]error[: 	\n])" | \
588		egrep -v "Ignoring unknown host" | \
589		egrep -v "cc .* -o error " | \
590		egrep -v "warning" >> $mail_msg_file
591	if [ "$?" = "0" ]; then
592		build_ok=n
593		this_build_ok=n
594	fi
595	grep "bootblock image is .* bytes too big" $SRC/${INSTALLOG}.out \
596		>> $mail_msg_file
597	if [ "$?" = "0" ]; then
598		build_ok=n
599		this_build_ok=n
600	fi
601
602	if [ "$W_FLAG" = "n" ]; then
603		echo "\n==== Build warnings ($LABEL) ====\n" >>$mail_msg_file
604		egrep -i warning: $SRC/${INSTALLOG}.out \
605			| egrep -v '^tic:' \
606			| egrep -v "symbol \`timezone' has differing types:" \
607		        | egrep -v "parameter <PSTAMP> set to" \
608			| egrep -v "Ignoring unknown host" \
609			| egrep -v "redefining segment flags attribute for" \
610			>> $mail_msg_file
611	fi
612
613	echo "\n==== Ended OS-Net source build at `date` ($LABEL) ====\n" \
614		>> $LOGFILE
615
616	echo "\n==== Elapsed build time ($LABEL) ====\n" >>$mail_msg_file
617	tail -3  $SRC/${INSTALLOG}.out >>$mail_msg_file
618
619	if [ "$i_FLAG" = "n" -a "$W_FLAG" = "n" ]; then
620		rm -f $SRC/${NOISE}.ref
621		if [ -f $SRC/${NOISE}.out ]; then
622			mv $SRC/${NOISE}.out $SRC/${NOISE}.ref
623		fi
624		grep : $SRC/${INSTALLOG}.out \
625			| egrep -v '^/' \
626			| egrep -v '^(Start|Finish|real|user|sys|./bld_awk)' \
627			| egrep -v '^tic:' \
628			| egrep -v '^mcs' \
629			| egrep -v '^LD_LIBRARY_PATH=' \
630			| egrep -v 'ar: creating' \
631			| egrep -v 'ar: writing' \
632			| egrep -v 'conflicts:' \
633			| egrep -v ':saved created' \
634			| egrep -v '^stty.*c:' \
635			| egrep -v '^mfgname.c:' \
636			| egrep -v '^uname-i.c:' \
637			| egrep -v '^volumes.c:' \
638			| egrep -v '^lint library construction:' \
639			| egrep -v 'tsort: INFORM:' \
640			| egrep -v 'stripalign:' \
641			| egrep -v 'chars, width' \
642			| egrep -v "symbol \`timezone' has differing types:" \
643			| egrep -v 'PSTAMP' \
644			| egrep -v '|%WHOANDWHERE%|' \
645			| egrep -v '^Manifying' \
646			| egrep -v 'Ignoring unknown host' \
647			| egrep -v 'Processing method:' \
648			| egrep -v '^Writing' \
649			| egrep -v 'spellin1:' \
650			| egrep -v '^adding:' \
651			| egrep -v "^echo 'msgid" \
652			| egrep -v '^echo ' \
653			| egrep -v '\.c:$' \
654			| egrep -v '^Adding file:' \
655			| egrep -v 'CLASSPATH=' \
656			| egrep -v '\/var\/mail\/:saved' \
657			| egrep -v -- '-DUTS_VERSION=' \
658			| egrep -v '^Running Mkbootstrap' \
659			| egrep -v '^Applet length read:' \
660			| egrep -v 'bytes written:' \
661			| egrep -v '^File:SolarisAuthApplet.bin' \
662			| egrep -v -i 'jibversion' \
663			| egrep -v '^Output size:' \
664			| egrep -v '^Solo size statistics:' \
665			| egrep -v '^Using ROM API Version' \
666			| egrep -v '^Zero Signature length:' \
667			| egrep -v '^Note \(probably harmless\):' \
668			| egrep -v '::' \
669			| egrep -v -- '-xcache' \
670			| egrep -v '^\+' \
671			| egrep -v '^cc1: note: -fwritable-strings' \
672			| egrep -v 'svccfg-native -s svc:/' \
673			| sort | uniq >$SRC/${NOISE}.out
674		if [ ! -f $SRC/${NOISE}.ref ]; then
675			cp $SRC/${NOISE}.out $SRC/${NOISE}.ref
676		fi
677		echo "\n==== Build noise differences ($LABEL) ====\n" \
678			>>$mail_msg_file
679		diff $SRC/${NOISE}.ref $SRC/${NOISE}.out >>$mail_msg_file
680	fi
681
682	#
683	#	Re-sign selected binaries using signing server
684	#	(gatekeeper builds only)
685	#
686	if [ -n "$CODESIGN_USER" -a "$this_build_ok" = "y" ]; then
687		echo "\n==== Signing proto area at `date` ====\n" >> $LOGFILE
688		signing_file="${TMPDIR}/signing"
689		rm -f ${signing_file}
690		export CODESIGN_USER
691		signproto $SRC/tools/codesign/creds 2>&1 | \
692			tee -a ${signing_file} >> $LOGFILE
693		echo "\n==== Finished signing proto area at `date` ====\n" \
694		    >> $LOGFILE
695		echo "\n==== Crypto module signing errors ($LABEL) ====\n" \
696		    >> $mail_msg_file
697		egrep 'WARNING|ERROR' ${signing_file} >> $mail_msg_file
698		if (( $? == 0 )) ; then
699			build_ok=n
700			this_build_ok=n
701		fi
702	fi
703
704	#
705	#	Create cpio archives for preintegration testing (PIT)
706	#
707	if [ "$a_FLAG" = "y" -a "$this_build_ok" = "y" ]; then
708		echo "\n==== Creating $LABEL cpio archives at `date` ====\n" \
709			>> $LOGFILE
710		makebfu_filt makebfu
711		# hack for test folks
712		if [ -z "`echo $PARENT_WS|egrep '^\/ws\/'`" ]; then
713			X=/net/`uname -n`${CPIODIR}
714		else
715			X=${CPIODIR}
716		fi
717		echo "Archive_directory: ${X}" >${TMPDIR}/f
718		cp ${TMPDIR}/f $(dirname $(dirname ${CPIODIR}))/.${MACH}_wgtrun
719		rm -f ${TMPDIR}/f
720
721	else
722		echo "\n==== Not creating $LABEL cpio archives ====\n" \
723			>> $LOGFILE
724	fi
725
726	#
727	#	Building Packages
728	#
729	if [ "$p_FLAG" = "y" -a "$this_build_ok" = "y" ]; then
730		echo "\n==== Creating $LABEL packages at `date` ====\n" \
731			>> $LOGFILE
732		rm -f $SRC/pkgdefs/${INSTALLOG}.out
733		echo "Clearing out $PKGARCHIVE ..." >> $LOGFILE
734		rm -rf $PKGARCHIVE
735		mkdir -p $PKGARCHIVE
736
737		#
738		# Optional build of sparc realmode on i386
739		#
740		if [ "$MACH" = "i386" ] && [ "${SPARC_RM_PKGARCHIVE}" ]; then
741			echo "Clearing out ${SPARC_RM_PKGARCHIVE} ..." \
742				>> $LOGFILE
743			rm -rf ${SPARC_RM_PKGARCHIVE}
744			mkdir -p ${SPARC_RM_PKGARCHIVE}
745		fi
746
747		cd $SRC/pkgdefs
748		$MAKE -e install 2>&1 | \
749			tee -a $SRC/pkgdefs/${INSTALLOG}.out >> $LOGFILE
750		echo "\n==== Package build errors ($LABEL) ====\n" \
751			>> $mail_msg_file
752		egrep "${MAKE}|ERROR|WARNING" $SRC/pkgdefs/${INSTALLOG}.out | \
753			grep ':' | \
754			grep -v PSTAMP | \
755			egrep -v "Ignoring unknown host" \
756			>> $mail_msg_file
757	else
758		echo "\n==== Not creating $LABEL packages ====\n" >> $LOGFILE
759	fi
760
761	ROOT=$ORIGROOT
762}
763
764# Usage: dolint /dir y|n
765# Arg. 2 is a flag to turn on/off the lint diff output
766dolint() {
767	if [ ! -d "$1" ]; then
768		echo "dolint error: $1 is not a directory"
769		exit 1
770	fi
771
772	if [ "$2" != "y" -a "$2" != "n" ]; then
773		echo "dolint internal error: $2 should be 'y' or 'n'"
774		exit 1
775	fi
776
777	lintdir=$1
778	dodiff=$2
779	base=`basename $lintdir`
780	LINTOUT=$lintdir/lint-${MACH}.out
781	LINTNOISE=$lintdir/lint-noise-${MACH}
782	export ENVLDLIBS1=`myldlibs $ROOT`
783	export ENVCPPFLAGS1=`myheaders $ROOT`
784
785	set_debug_build_flags
786
787	#
788	#	'$MAKE lint' in $lintdir
789	#
790	echo "\n==== Begin '$MAKE lint' of $base at `date` ====\n" >> $LOGFILE
791
792	# remove old lint.out
793	rm -f $lintdir/lint.out $lintdir/lint-noise.out
794	if [ -f $lintdir/lint-noise.ref ]; then
795		mv $lintdir/lint-noise.ref ${LINTNOISE}.ref
796	fi
797
798	rm -f $LINTOUT
799	cd $lintdir
800	#
801	# Remove all .ln files to ensure a full reference file
802	#
803	rm -f Nothing_to_remove \
804	    `find . \( -name SCCS -o -name .hg -o -name .svn \) \
805	    	-prune -o -type f -name '*.ln' -print `
806
807	/bin/time $MAKE -ek lint 2>&1 | \
808	    tee -a $LINTOUT >> $LOGFILE
809	echo "\n==== '$MAKE lint' of $base ERRORS ====\n" >> $mail_msg_file
810	grep "$MAKE:" $LINTOUT |
811		egrep -v "Ignoring unknown host" \
812		>> $mail_msg_file
813
814	echo "\n==== Ended '$MAKE lint' of $base at `date` ====\n" >> $LOGFILE
815
816	echo "\n==== Elapsed time of '$MAKE lint' of $base ====\n" \
817		>>$mail_msg_file
818	tail -3  $LINTOUT >>$mail_msg_file
819
820	rm -f ${LINTNOISE}.ref
821	if [ -f ${LINTNOISE}.out ]; then
822		mv ${LINTNOISE}.out ${LINTNOISE}.ref
823	fi
824        grep : $LINTOUT | \
825		egrep -v '^(real|user|sys)' |
826		egrep -v '(library construction)' | \
827		egrep -v ': global crosschecks' | \
828		egrep -v 'Ignoring unknown host' | \
829		egrep -v '\.c:$' | \
830		sort | uniq > ${LINTNOISE}.out
831	if [ ! -f ${LINTNOISE}.ref ]; then
832		cp ${LINTNOISE}.out ${LINTNOISE}.ref
833	fi
834	if [ "$dodiff" != "n" ]; then
835		echo "\n==== lint warnings $base ====\n" \
836			>>$mail_msg_file
837		# should be none, though there are a few that were filtered out
838		# above
839		egrep -i '(warning|lint):' ${LINTNOISE}.out \
840			| sort | uniq >> $mail_msg_file
841		echo "\n==== lint noise differences $base ====\n" \
842			>> $mail_msg_file
843		diff ${LINTNOISE}.ref ${LINTNOISE}.out \
844			>> $mail_msg_file
845	fi
846}
847
848# Install proto area from IHV build
849
850copy_ihv_proto() {
851
852	echo "\n==== Installing IHV proto area ====\n" \
853		>> $LOGFILE
854	if [ -d "$IA32_IHV_ROOT" ]; then
855		if [ ! -d "$ROOT" ]; then
856			echo "mkdir -p $ROOT" >> $LOGFILE
857			mkdir -p $ROOT
858		fi
859		echo "copying $IA32_IHV_ROOT to $ROOT\n" >> $LOGFILE
860		cd $IA32_IHV_ROOT
861		tar -cf - . | (cd $ROOT; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
862	else
863		echo "$IA32_IHV_ROOT: not found" >> $LOGFILE
864	fi
865
866	if [ "$MULTI_PROTO" = yes ]; then
867		if [ ! -d "$ROOT-nd" ]; then
868			echo "mkdir -p $ROOT-nd" >> $LOGFILE
869			mkdir -p $ROOT-nd
870		fi
871		# If there's a non-debug version of the IHV proto area,
872		# copy it, but copy something if there's not.
873		if [ -d "$IA32_IHV_ROOT-nd" ]; then
874			echo "copying $IA32_IHV_ROOT-nd to $ROOT-nd\n" >> $LOGFILE
875			cd $IA32_IHV_ROOT-nd
876		elif [ -d "$IA32_IHV_ROOT" ]; then
877			echo "copying $IA32_IHV_ROOT to $ROOT-nd\n" >> $LOGFILE
878			cd $IA32_IHV_ROOT
879		else
880			echo "$IA32_IHV_ROOT{-nd,}: not found" >> $LOGFILE
881			return
882		fi
883		tar -cf - . | (cd $ROOT-nd; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
884	fi
885}
886
887# Install IHV packages in PKGARCHIVE
888# usage: copy_ihv_pkgs LABEL SUFFIX
889copy_ihv_pkgs() {
890	LABEL=$1
891	SUFFIX=$2
892	# always use non-DEBUG IHV packages
893	IA32_IHV_PKGS=${IA32_IHV_PKGS_ORIG}-nd
894	PKGARCHIVE=${PKGARCHIVE_ORIG}${SUFFIX}
895
896	echo "\n==== Installing IHV packages from $IA32_IHV_PKGS ($LABEL) ====\n" \
897		>> $LOGFILE
898	if [ -d "$IA32_IHV_PKGS" ]; then
899		cd $IA32_IHV_PKGS
900		tar -cf - * | \
901		   (cd $PKGARCHIVE; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
902	else
903		echo "$IA32_IHV_PKGS: not found" >> $LOGFILE
904	fi
905
906	echo "\n==== Installing IHV packages from $IA32_IHV_BINARY_PKGS ($LABEL) ====\n" \
907		>> $LOGFILE
908	if [ -d "$IA32_IHV_BINARY_PKGS" ]; then
909		cd $IA32_IHV_BINARY_PKGS
910		tar -cf - * | \
911		    (cd $PKGARCHIVE; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
912	else
913		echo "$IA32_IHV_BINARY_PKGS: not found" >> $LOGFILE
914	fi
915}
916
917#
918# Build and install the onbld tools.
919#
920# usage: build_tools DESTROOT
921#
922# returns non-zero status if the build was successful.
923#
924build_tools() {
925	DESTROOT=$1
926
927	INSTALLOG=install-${MACH}
928
929	echo "\n==== Building tools at `date` ====\n" \
930		>> $LOGFILE
931
932	rm -f ${TOOLS}/${INSTALLOG}.out
933	cd ${TOOLS}
934	/bin/time $MAKE ROOT=${DESTROOT} -e install 2>&1 | \
935	    tee -a ${TOOLS}/${INSTALLOG}.out >> $LOGFILE
936
937	echo "\n==== Tools build errors ====\n" >> $mail_msg_file
938
939	egrep ":" ${TOOLS}/${INSTALLOG}.out |
940		egrep -e "(${MAKE}:|[ 	]error[: 	\n])" | \
941		egrep -v "Ignoring unknown host" | \
942		egrep -v warning >> $mail_msg_file
943	return $?
944}
945
946#
947# Set up to use locally installed tools.
948#
949# usage: use_tools TOOLSROOT
950#
951use_tools() {
952	TOOLSROOT=$1
953
954	STABS=${TOOLSROOT}/opt/onbld/bin/${MACH}/stabs
955	export STABS
956	CTFSTABS=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfstabs
957	export CTFSTABS
958	GENOFFSETS=${TOOLSROOT}/opt/onbld/bin/genoffsets
959	export GENOFFSETS
960
961	CTFCONVERT=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfconvert
962	export CTFCONVERT
963	CTFMERGE=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfmerge
964	export CTFMERGE
965
966	CTFCVTPTBL=${TOOLSROOT}/opt/onbld/bin/ctfcvtptbl
967	export CTFCVTPTBL
968	CTFFINDMOD=${TOOLSROOT}/opt/onbld/bin/ctffindmod
969	export CTFFINDMOD
970
971	if [ "$VERIFY_ELFSIGN" = "y" ]; then
972		ELFSIGN=${TOOLSROOT}/opt/onbld/bin/elfsigncmp
973	else
974		ELFSIGN=${TOOLSROOT}/opt/onbld/bin/${MACH}/elfsign
975	fi
976	export ELFSIGN
977
978	PATH="${TOOLSROOT}/opt/onbld/bin/${MACH}:${PATH}"
979	PATH="${TOOLSROOT}/opt/onbld/bin:${PATH}"
980	export PATH
981
982	echo "\n==== New environment settings. ====\n" >> $LOGFILE
983	echo "STABS=${STABS}" >> $LOGFILE
984	echo "CTFSTABS=${CTFSTABS}" >> $LOGFILE
985	echo "CTFCONVERT=${CTFCONVERT}" >> $LOGFILE
986	echo "CTFMERGE=${CTFMERGE}" >> $LOGFILE
987	echo "CTFCVTPTBL=${CTFCVTPTBL}" >> $LOGFILE
988	echo "CTFFINDMOD=${CTFFINDMOD}" >> $LOGFILE
989	echo "ELFSIGN=${ELFSIGN}" >> $LOGFILE
990	echo "PATH=${PATH}" >> $LOGFILE
991}
992
993staffer() {
994	if [ $ISUSER -ne 0 ]; then
995		"$@"
996	else
997		arg="\"$1\""
998		shift
999		for i
1000		do
1001			arg="$arg \"$i\""
1002		done
1003		eval su $STAFFER -c \'$arg\'
1004	fi
1005}
1006
1007#
1008# Verify that the closed tree is present if it needs to be.
1009# Sets CLOSED_IS_PRESENT for future use.
1010#
1011check_closed_tree() {
1012	if [ -z "$CLOSED_IS_PRESENT" ]; then
1013		if [ -d $SRC/../closed ]; then
1014			CLOSED_IS_PRESENT="yes"
1015		else
1016			CLOSED_IS_PRESENT="no"
1017		fi
1018		export CLOSED_IS_PRESENT
1019	fi
1020	if [[ "$CLOSED_IS_PRESENT" = no && ! -d "$ON_CLOSED_BINS" ]]; then
1021		#
1022		# If it's an old (pre-split) tree or an empty
1023		# workspace, don't complain.
1024		#
1025		if grep -s CLOSED_BUILD $SRC/Makefile.master > /dev/null; then
1026			echo "If the closed sources are not present," \
1027			    "ON_CLOSED_BINS"
1028			echo "must point to the closed binaries tree."
1029			build_ok=n
1030			exit 1
1031		fi
1032	fi
1033}
1034
1035obsolete_build() {
1036    	echo "WARNING: Obsolete $1 build requested; request will be ignored"
1037}
1038
1039#
1040# wrapper over wsdiff.
1041# usage: do_wsdiff LABEL OLDPROTO NEWPROTO
1042#
1043do_wsdiff() {
1044	label=$1
1045	oldproto=$2
1046	newproto=$3
1047
1048	echo "\n==== Objects that differ since last build ($label) ====\n" | \
1049	    tee -a $LOGFILE >> $mail_msg_file
1050
1051	wsdiff="wsdiff"
1052	[ "$t_FLAG" = y ] && wsdiff="wsdiff -t"
1053
1054	$wsdiff -r ${TMPDIR}/wsdiff.results $oldproto $newproto 2>&1 | \
1055		    tee -a $LOGFILE >> $mail_msg_file
1056}
1057
1058#
1059# Functions for setting build flags (debug/non-debug).  Keep them
1060# together.
1061#
1062
1063set_non_debug_build_flags() {
1064	export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
1065	export RELEASE_BUILD ; RELEASE_BUILD=
1066	unset EXTRA_OPTIONS
1067	unset EXTRA_CFLAGS
1068}
1069
1070set_debug_build_flags() {
1071	export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
1072	unset RELEASE_BUILD
1073	unset EXTRA_OPTIONS
1074	unset EXTRA_CFLAGS
1075}
1076
1077
1078MACH=`uname -p`
1079
1080if [ "$OPTHOME" = "" ]; then
1081	OPTHOME=/opt
1082	export OPTHOME
1083fi
1084if [ "$TEAMWARE" = "" ]; then
1085	TEAMWARE=$OPTHOME/teamware
1086	export TEAMWARE
1087fi
1088
1089USAGE='Usage: nightly [-in] [-V VERS ] [ -S E|D|H|O ] <env_file>
1090
1091Where:
1092	-i	Fast incremental options (no clobber, lint, check)
1093	-n      Do not do a bringover
1094	-V VERS set the build version string to VERS
1095	-S	Build a variant of the source product
1096		E - build exportable source
1097		D - build domestic source (exportable + crypt)
1098		H - build hybrid source (binaries + deleted source)
1099		O - build (only) open source
1100
1101	<env_file>  file in Bourne shell syntax that sets and exports
1102	variables that configure the operation of this script and many of
1103	the scripts this one calls. If <env_file> does not exist,
1104	it will be looked for in $OPTHOME/onbld/env.
1105
1106non-DEBUG is the default build type. Build options can be set in the
1107NIGHTLY_OPTIONS variable in the <env_file> as follows:
1108
1109	-A	check for ABI differences in .so files
1110	-C	check for cstyle/hdrchk errors
1111	-D	do a build with DEBUG on
1112	-F	do _not_ do a non-DEBUG build
1113	-G	gate keeper default group of options (-au)
1114	-I	integration engineer default group of options (-ampu)
1115	-M	do not run pmodes (safe file permission checker)
1116	-N	do not run protocmp
1117	-O	generate OpenSolaris deliverables
1118	-R	default group of options for building a release (-mp)
1119	-U	update proto area in the parent
1120	-V VERS set the build version string to VERS
1121	-X	copy x86 IHV proto area
1122	-a	create cpio archives
1123	-f	find unreferenced files
1124	-i	do an incremental build (no "make clobber")
1125	-l	do "make lint" in $LINTDIRS (default: $SRC y)
1126	-m	send mail to $MAILTO at end of build
1127	-n      do not do a bringover
1128	-o	build using root privileges to set OWNER/GROUP (old style)
1129	-p	create packages
1130	-r	check ELF runtime attributes in the proto area
1131	-t	build and use the tools in $SRC/tools
1132	-u	update proto_list_$MACH and friends in the parent workspace;
1133		when used with -f, also build an unrefmaster.out in the parent
1134	-w	report on differences between previous and current proto areas
1135	-z	compress cpio archives with gzip
1136	-W	Do not report warnings (freeware gate ONLY)
1137	-S	Build a variant of the source product
1138		E - build exportable source
1139		D - build domestic source (exportable + crypt)
1140		H - build hybrid source (binaries + deleted source)
1141		O - build (only) open source
1142'
1143#
1144#	-x	less public handling of xmod source for the source product
1145#
1146#	A log file will be generated under the name $LOGFILE
1147#	for partially completed build and log.`date '+%F'`
1148#	in the same directory for fully completed builds.
1149#
1150
1151# default values for low-level FLAGS; G I R are group FLAGS
1152A_FLAG=n
1153a_FLAG=n
1154C_FLAG=n
1155D_FLAG=n
1156F_FLAG=n
1157f_FLAG=n
1158i_FLAG=n; i_CMD_LINE_FLAG=n
1159l_FLAG=n
1160M_FLAG=n
1161m_FLAG=n
1162N_FLAG=n
1163n_FLAG=n
1164O_FLAG=n
1165o_FLAG=n
1166P_FLAG=n
1167p_FLAG=n
1168r_FLAG=n
1169T_FLAG=n
1170t_FLAG=y
1171U_FLAG=n
1172u_FLAG=n
1173V_FLAG=n
1174W_FLAG=n
1175w_FLAG=n
1176X_FLAG=n
1177z_FLAG=n
1178SD_FLAG=n
1179SE_FLAG=n
1180SH_FLAG=n
1181SO_FLAG=n
1182#
1183XMOD_OPT=
1184#
1185build_ok=y
1186
1187is_source_build() {
1188	[ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o \
1189	    "$SH_FLAG" = "y" -o "$SO_FLAG" = "y" ]
1190	return $?
1191}
1192
1193#
1194# examine arguments
1195#
1196
1197#
1198# single function for setting -S flag and doing error checking.
1199# usage: set_S_flag <type>
1200# where <type> is the source build type ("E", "D", ...).
1201#
1202set_S_flag() {
1203	if is_source_build; then
1204		echo "Can only build one source variant at a time."
1205		exit 1
1206	fi
1207	if [ "$1" = "E" ]; then
1208		SE_FLAG=y
1209	elif [ "$1" = "D" ]; then
1210		SD_FLAG=y
1211	elif [ "$1" = "H" ]; then
1212		SH_FLAG=y
1213	elif [ "$1" = "O" ]; then
1214		SO_FLAG=y
1215	else
1216		echo "$USAGE"
1217		exit 1
1218	fi
1219}
1220
1221OPTIND=1
1222while getopts inS:tV: FLAG
1223do
1224	case $FLAG in
1225	  i )	i_FLAG=y; i_CMD_LINE_FLAG=y
1226		;;
1227	  n )	n_FLAG=y
1228		;;
1229	  S )
1230		set_S_flag $OPTARG
1231		;;
1232	 +t )	t_FLAG=n
1233		;;
1234	  V )	V_FLAG=y
1235		V_ARG="$OPTARG"
1236		;;
1237	 \? )	echo "$USAGE"
1238		exit 1
1239		;;
1240	esac
1241done
1242
1243# correct argument count after options
1244shift `expr $OPTIND - 1`
1245
1246# test that the path to the environment-setting file was given
1247if [ $# -ne 1 ]; then
1248	echo "$USAGE"
1249	exit 1
1250fi
1251
1252# check if user is running nightly as root
1253# ISUSER is set non-zero if an ordinary user runs nightly, or is zero
1254# when root invokes nightly.
1255/usr/bin/id | grep '^uid=0(' >/dev/null 2>&1
1256ISUSER=$?;	export ISUSER
1257
1258#
1259# force locale to C
1260LC_COLLATE=C;	export LC_COLLATE
1261LC_CTYPE=C;	export LC_CTYPE
1262LC_MESSAGES=C;	export LC_MESSAGES
1263LC_MONETARY=C;	export LC_MONETARY
1264LC_NUMERIC=C;	export LC_NUMERIC
1265LC_TIME=C;	export LC_TIME
1266
1267# clear environment variables we know to be bad for the build
1268unset LD_OPTIONS
1269unset LD_AUDIT		LD_AUDIT_32		LD_AUDIT_64
1270unset LD_BIND_NOW	LD_BIND_NOW_32		LD_BIND_NOW_64
1271unset LD_BREADTH	LD_BREADTH_32		LD_BREADTH_64
1272unset LD_CONFIG		LD_CONFIG_32		LD_CONFIG_64
1273unset LD_DEBUG		LD_DEBUG_32		LD_DEBUG_64
1274unset LD_DEMANGLE	LD_DEMANGLE_32		LD_DEMANGLE_64
1275unset LD_FLAGS		LD_FLAGS_32		LD_FLAGS_64
1276unset LD_LIBRARY_PATH	LD_LIBRARY_PATH_32	LD_LIBRARY_PATH_64
1277unset LD_LOADFLTR	LD_LOADFLTR_32		LD_LOADFLTR_64
1278unset LD_NOAUDIT	LD_NOAUDIT_32		LD_NOAUDIT_64
1279unset LD_NOAUXFLTR	LD_NOAUXFLTR_32		LD_NOAUXFLTR_64
1280unset LD_NOCONFIG	LD_NOCONFIG_32		LD_NOCONFIG_64
1281unset LD_NODIRCONFIG	LD_NODIRCONFIG_32	LD_NODIRCONFIG_64
1282unset LD_NODIRECT	LD_NODIRECT_32		LD_NODIRECT_64
1283unset LD_NOLAZYLOAD	LD_NOLAZYLOAD_32	LD_NOLAZYLOAD_64
1284unset LD_NOOBJALTER	LD_NOOBJALTER_32	LD_NOOBJALTER_64
1285unset LD_NOVERSION	LD_NOVERSION_32		LD_NOVERSION_64
1286unset LD_ORIGIN		LD_ORIGIN_32		LD_ORIGIN_64
1287unset LD_PRELOAD	LD_PRELOAD_32		LD_PRELOAD_64
1288unset LD_PROFILE	LD_PROFILE_32		LD_PROFILE_64
1289
1290unset CONFIG
1291unset GROUP
1292unset OWNER
1293unset REMOTE
1294unset ENV
1295unset ARCH
1296unset CLASSPATH
1297unset NAME
1298
1299#
1300#	Setup environmental variables
1301#
1302if [ -f /etc/nightly.conf ]; then
1303	. /etc/nightly.conf
1304fi
1305
1306if [ -f $1 ]; then
1307	if [[ $1 = */* ]]; then
1308		. $1
1309	else
1310		. ./$1
1311	fi
1312else
1313	if [ -f $OPTHOME/onbld/env/$1 ]; then
1314		. $OPTHOME/onbld/env/$1
1315	else
1316		echo "Cannot find env file as either $1 or $OPTHOME/onbld/env/$1"
1317		exit 1
1318	fi
1319fi
1320
1321# contents of stdenv.sh inserted after next line:
1322# STDENV_START
1323# STDENV_END
1324
1325#
1326# place ourselves in a new task, respecting BUILD_PROJECT if set.
1327#
1328if [ -z "$BUILD_PROJECT" ]; then
1329	/usr/bin/newtask -c $$
1330else
1331	/usr/bin/newtask -c $$ -p $BUILD_PROJECT
1332fi
1333
1334ps -o taskid= -p $$ | read build_taskid
1335ps -o project= -p $$ | read build_project
1336
1337#
1338# See if NIGHTLY_OPTIONS is set
1339#
1340if [ "$NIGHTLY_OPTIONS" = "" ]; then
1341	NIGHTLY_OPTIONS="-aBm"
1342fi
1343
1344#
1345# If BRINGOVER_WS was not specified, let it default to CLONE_WS
1346#
1347if [ "$BRINGOVER_WS" = "" ]; then
1348	BRINGOVER_WS=$CLONE_WS
1349fi
1350
1351#
1352# If CLOSED_BRINGOVER_WS was not specified, let it default to CLOSED_CLONE_WS
1353#
1354if [ "$CLOSED_BRINGOVER_WS" = "" ]; then
1355	CLOSED_BRINGOVER_WS=$CLOSED_CLONE_WS
1356fi
1357
1358#
1359# If BRINGOVER_FILES was not specified, default to usr
1360#
1361if [ "$BRINGOVER_FILES" = "" ]; then
1362	BRINGOVER_FILES="usr"
1363fi
1364
1365#
1366# If the closed sources are not present, the closed binaries must be
1367# present for the build to succeed.  If there's no pointer to the
1368# closed binaries, flag that now, rather than forcing the user to wait
1369# a couple hours (or more) to find out.
1370#
1371orig_closed_is_present="$CLOSED_IS_PRESENT"
1372check_closed_tree
1373
1374#
1375# Note: changes to the option letters here should also be applied to the
1376#	bldenv script.  `d' is listed for backward compatibility.
1377#
1378NIGHTLY_OPTIONS=-${NIGHTLY_OPTIONS#-}
1379OPTIND=1
1380while getopts AaBCDdFfGIilMmNnOoPpRrS:TtUuWwXxz FLAG $NIGHTLY_OPTIONS
1381do
1382	case $FLAG in
1383	  A )	A_FLAG=y
1384		;;
1385	  a )	a_FLAG=y
1386		;;
1387	  B )	D_FLAG=y
1388		;; # old version of D
1389	  C )	C_FLAG=y
1390		;;
1391	  D )	D_FLAG=y
1392		;;
1393	  F )	F_FLAG=y
1394		;;
1395	  f )	f_FLAG=y
1396		;;
1397	  G )	a_FLAG=y
1398		u_FLAG=y
1399		;;
1400	  I )	a_FLAG=y
1401		m_FLAG=y
1402		p_FLAG=y
1403		u_FLAG=y
1404		;;
1405	  i )	i_FLAG=y
1406		;;
1407	  l )	l_FLAG=y
1408		;;
1409	  M )	M_FLAG=y
1410		;;
1411	  m )	m_FLAG=y
1412		;;
1413	  N )	N_FLAG=y
1414		;;
1415	  n )	n_FLAG=y
1416		;;
1417	  O )	O_FLAG=y
1418		;;
1419	  o )	o_FLAG=y
1420		;;
1421	  P )	P_FLAG=y
1422		;; # obsolete
1423	  p )	p_FLAG=y
1424		;;
1425	  R )	m_FLAG=y
1426		p_FLAG=y
1427		;;
1428	  r )	r_FLAG=y
1429		;;
1430	  S )
1431		set_S_flag $OPTARG
1432		;;
1433	  T )	T_FLAG=y
1434		;; # obsolete
1435	 +t )	t_FLAG=n
1436		;;
1437	  U )
1438		if [ -z "${PARENT_ROOT}" ]; then
1439			echo "PARENT_ROOT must be set if the U flag is" \
1440			    "present in NIGHTLY_OPTIONS."
1441			exit 1
1442		fi
1443		U_FLAG=y
1444		NIGHTLY_PARENT_ROOT=$PARENT_ROOT
1445		;;
1446	  u )	u_FLAG=y
1447		;;
1448	  W )	W_FLAG=y
1449		;;
1450
1451	  w )	w_FLAG=y
1452		;;
1453	  X )	# now that we no longer need realmode builds, just
1454		# copy IHV packages.  only meaningful on x86.
1455		if [ "$MACH" = "i386" ]; then
1456			X_FLAG=y
1457		fi
1458		;;
1459	  x )	XMOD_OPT="-x"
1460		;;
1461	  z )	z_FLAG=y
1462		;;
1463	 \? )	echo "$USAGE"
1464		exit 1
1465		;;
1466	esac
1467done
1468
1469if [ $ISUSER -ne 0 ]; then
1470	if [ "$o_FLAG" = "y" ]; then
1471		echo "Old-style build requires root permission."
1472		exit 1
1473	fi
1474
1475	# Set default value for STAFFER, if needed.
1476	if [ -z "$STAFFER" -o "$STAFFER" = "nobody" ]; then
1477		STAFFER=`/usr/xpg4/bin/id -un`
1478		export STAFFER
1479	fi
1480fi
1481
1482if [ -z "$MAILTO" -o "$MAILTO" = "nobody" ]; then
1483	MAILTO=$STAFFER
1484	export MAILTO
1485fi
1486
1487PATH="$OPTHOME/onbld/bin:$OPTHOME/onbld/bin/${MACH}:/usr/ccs/bin"
1488PATH="$PATH:$OPTHOME/SUNWspro/bin:$TEAMWARE/bin:/usr/bin:/usr/sbin:/usr/ucb"
1489PATH="$PATH:/usr/openwin/bin:/usr/sfw/bin:/opt/sfw/bin:."
1490export PATH
1491
1492# roots of source trees, both relative to $SRC and absolute.
1493relsrcdirs="."
1494if [[ -d $SRC/../closed && "$CLOSED_IS_PRESENT" != no ]]; then
1495	relsrcdirs="$relsrcdirs ../closed"
1496fi
1497abssrcdirs=""
1498for d in $relsrcdirs; do
1499	abssrcdirs="$abssrcdirs $SRC/$d"
1500done
1501
1502unset CH
1503if [ "$o_FLAG" = "y" ]; then
1504# root invoked old-style build -- make sure it works as it always has
1505# by exporting 'CH'.  The current Makefile.master doesn't use this, but
1506# the old ones still do.
1507	PROTOCMPTERSE="protocmp.terse"
1508	CH=
1509	export CH
1510else
1511	PROTOCMPTERSE="protocmp.terse -gu"
1512fi
1513POUND_SIGN="#"
1514
1515# we export POUND_SIGN to speed up the build process -- prevents evaluation of
1516# the Makefile.master definitions.
1517export o_FLAG X_FLAG POUND_SIGN
1518
1519maketype="distributed"
1520MAKE=dmake
1521# get the dmake version string alone
1522DMAKE_VERSION=$( $MAKE -v )
1523DMAKE_VERSION=${DMAKE_VERSION#*: }
1524# focus in on just the dotted version number alone
1525DMAKE_MAJOR=$( echo $DMAKE_VERSION | \
1526	sed -e 's/.*\<\([^.]*\.[^   ]*\).*$/\1/' )
1527# extract the second (or final) integer
1528DMAKE_MINOR=${DMAKE_MAJOR#*.}
1529DMAKE_MINOR=${DMAKE_MINOR%%.*}
1530# extract the first integer
1531DMAKE_MAJOR=${DMAKE_MAJOR%%.*}
1532CHECK_DMAKE=${CHECK_DMAKE:-y}
1533# x86 was built on the 12th, sparc on the 13th.
1534if [ "$CHECK_DMAKE" = "y" -a \
1535     "$DMAKE_VERSION" != "Sun Distributed Make 7.3 2003/03/12" -a \
1536     "$DMAKE_VERSION" != "Sun Distributed Make 7.3 2003/03/13" -a \( \
1537     "$DMAKE_MAJOR" -lt 7 -o \
1538     "$DMAKE_MAJOR" -eq 7 -a "$DMAKE_MINOR" -lt 4 \) ]; then
1539	if [ -z "$DMAKE_VERSION" ]; then
1540		echo "$MAKE is missing."
1541		exit 1
1542	fi
1543	echo `whence $MAKE`" version is:"
1544	echo "  ${DMAKE_VERSION}"
1545	cat <<EOF
1546
1547This version may not be safe for use.  Either set TEAMWARE to a better
1548path or (if you really want to use this version of dmake anyway), add
1549the following to your environment to disable this check:
1550
1551  CHECK_DMAKE=n
1552EOF
1553	exit 1
1554fi
1555export PATH
1556export MAKE
1557
1558if [ "${SUNWSPRO}" != "" ]; then
1559	PATH="${SUNWSPRO}/bin:$PATH"
1560	export PATH
1561fi
1562
1563hostname=`uname -n`
1564if [ ! -f $HOME/.make.machines ]; then
1565	DMAKE_MAX_JOBS=4
1566else
1567	DMAKE_MAX_JOBS="`grep $hostname $HOME/.make.machines | \
1568	    tail -1 | awk -F= '{print $ 2;}'`"
1569	if [ "$DMAKE_MAX_JOBS" = "" ]; then
1570		DMAKE_MAX_JOBS=4
1571	fi
1572fi
1573DMAKE_MODE=parallel;
1574export DMAKE_MODE
1575export DMAKE_MAX_JOBS
1576
1577if [ -z "${ROOT}" ]; then
1578	echo "ROOT must be set."
1579	exit 1
1580fi
1581
1582#
1583# if -V flag was given, reset VERSION to V_ARG
1584#
1585if [ "$V_FLAG" = "y" ]; then
1586	VERSION=$V_ARG
1587fi
1588
1589#
1590# Check for IHV root for copying ihv proto area
1591#
1592if [ "$X_FLAG" = "y" ]; then
1593        if [ "$IA32_IHV_ROOT" = "" ]; then
1594		echo "IA32_IHV_ROOT: must be set for copying ihv proto"
1595		args_ok=n
1596        fi
1597        if [ ! -d "$IA32_IHV_ROOT" ]; then
1598                echo "$IA32_IHV_ROOT: not found"
1599                args_ok=n
1600        fi
1601        if [ "$IA32_IHV_WS" = "" ]; then
1602		echo "IA32_IHV_WS: must be set for copying ihv proto"
1603		args_ok=n
1604        fi
1605        if [ ! -d "$IA32_IHV_WS" ]; then
1606                echo "$IA32_IHV_WS: not found"
1607                args_ok=n
1608        fi
1609fi
1610
1611# Append source version
1612if [ "$SE_FLAG" = "y" ]; then
1613	VERSION="${VERSION}:EXPORT"
1614fi
1615
1616if [ "$SD_FLAG" = "y" ]; then
1617	VERSION="${VERSION}:DOMESTIC"
1618fi
1619
1620if [ "$SH_FLAG" = "y" ]; then
1621	VERSION="${VERSION}:MODIFIED_SOURCE_PRODUCT"
1622fi
1623
1624if [ "$SO_FLAG" = "y" ]; then
1625	VERSION="${VERSION}:OPEN_ONLY"
1626fi
1627
1628TMPDIR="/tmp/nightly.tmpdir.$$"
1629export TMPDIR
1630rm -rf ${TMPDIR}
1631mkdir -p $TMPDIR || exit 1
1632
1633#
1634# Keep elfsign's use of pkcs11_softtoken from looking in the user home
1635# directory, which doesn't always work.   Needed until all build machines
1636# have the fix for 6271754
1637#
1638SOFTTOKEN_DIR=$TMPDIR
1639export SOFTTOKEN_DIR
1640
1641TOOLS=${SRC}/tools
1642TOOLS_PROTO=${TOOLS}/proto
1643
1644unset   CFLAGS LD_LIBRARY_PATH LDFLAGS
1645
1646# create directories that are automatically removed if the nightly script
1647# fails to start correctly
1648newdir() {
1649	dir=$1
1650	toadd=
1651	while [ ! -d $dir ]; do
1652		toadd="$dir $toadd"
1653		dir=`dirname $dir`
1654	done
1655	torm=
1656	newlist=
1657	for dir in $toadd; do
1658		if staffer mkdir $dir; then
1659			newlist="$ISUSER $dir $newlist"
1660			torm="$dir $torm"
1661		else
1662			[ -z "$torm" ] || staffer rmdir $torm
1663			return 1
1664		fi
1665	done
1666	newdirlist="$newlist $newdirlist"
1667	return 0
1668}
1669newdirlist=
1670
1671[ -d $CODEMGR_WS ] || newdir $CODEMGR_WS || exit 1
1672
1673# since this script assumes the build is from full source, it nullifies
1674# variables likely to have been set by a "ws" script; nullification
1675# confines the search space for headers and libraries to the proto area
1676# built from this immediate source.
1677ENVLDLIBS1=
1678ENVLDLIBS2=
1679ENVLDLIBS3=
1680ENVCPPFLAGS1=
1681ENVCPPFLAGS2=
1682ENVCPPFLAGS3=
1683ENVCPPFLAGS4=
1684PARENT_ROOT=
1685
1686export ENVLDLIBS3 ENVCPPFLAGS1 ENVCPPFLAGS2 ENVCPPFLAGS3 ENVCPPFLAGS4 \
1687	PARENT_ROOT
1688
1689CPIODIR_ORIG=$CPIODIR
1690PKGARCHIVE_ORIG=$PKGARCHIVE
1691IA32_IHV_PKGS_ORIG=$IA32_IHV_PKGS
1692if [ "$SPARC_RM_PKGARCHIVE" ]; then
1693	SPARC_RM_PKGARCHIVE_ORIG=$SPARC_RM_PKGARCHIVE
1694fi
1695
1696#
1697# Juggle the logs and optionally send mail on completion.
1698#
1699
1700logshuffle() {
1701    	LLOG="$ATLOG/log.`date '+%F.%H:%M'`"
1702	if [ -f $LLOG -o -d $LLOG ]; then
1703	    	LLOG=$LLOG.$$
1704	fi
1705	mkdir $LLOG
1706	export LLOG
1707
1708	if [ "$build_ok" = "y" ]; then
1709		mv $ATLOG/proto_list_${MACH} $LLOG
1710
1711		if [ -f $TMPDIR/wsdiff.results ]; then
1712		    mv $TMPDIR/wsdiff.results $LLOG
1713		fi
1714
1715		if [ -f $TMPDIR/wsdiff-nd.results ]; then
1716			mv $TMPDIR/wsdiff-nd.results $LLOG
1717		fi
1718	fi
1719
1720	#
1721	# Now that we're about to send mail, it's time to check the noise
1722	# file.  In the event that an error occurs beyond this point, it will
1723	# be recorded in the nightly.log file, but nowhere else.  This would
1724	# include only errors that cause the copying of the noise log to fail
1725	# or the mail itself not to be sent.
1726	#
1727
1728	exec >>$LOGFILE 2>&1
1729	if [ -s $build_noise_file ]; then
1730	    	echo "\n==== Nightly build noise ====\n" |
1731		    tee -a $LOGFILE >>$mail_msg_file
1732		cat $build_noise_file >>$LOGFILE
1733		cat $build_noise_file >>$mail_msg_file
1734		echo | tee -a $LOGFILE >>$mail_msg_file
1735	fi
1736	rm -f $build_noise_file
1737
1738	case "$build_ok" in
1739		y)
1740			state=Completed
1741			;;
1742		i)
1743			state=Interrupted
1744			;;
1745		*)
1746	    		state=Failed
1747			;;
1748	esac
1749	NIGHTLY_STATUS=$state
1750	export NIGHTLY_STATUS
1751
1752	run_hook POST_NIGHTLY $state
1753	run_hook SYS_POST_NIGHTLY $state
1754
1755	cat $build_time_file $build_environ_file $mail_msg_file \
1756	    > ${LLOG}/mail_msg
1757	if [ "$m_FLAG" = "y" ]; then
1758	    	cat ${LLOG}/mail_msg | /usr/bin/mailx -s \
1759	"Nightly ${MACH} Build of `basename ${CODEMGR_WS}` ${state}." \
1760			${MAILTO}
1761	fi
1762
1763	if [ "$u_FLAG" = "y" -a "$build_ok" = "y" ]; then
1764	    	staffer cp ${LLOG}/mail_msg $PARENT_WS/usr/src/mail_msg-${MACH}
1765		staffer cp $LOGFILE $PARENT_WS/usr/src/nightly-${MACH}.log
1766	fi
1767
1768	mv $LOGFILE $LLOG
1769}
1770
1771#
1772#	Remove the locks and temporary files on any exit
1773#
1774cleanup() {
1775    	logshuffle
1776
1777	[ -z "$lockfile" ] || staffer rm -f $lockfile
1778	[ -z "$atloglockfile" ] || rm -f $atloglockfile
1779	[ -z "$ulockfile" ] || staffer rm -f $ulockfile
1780	[ -z "$Ulockfile" ] || rm -f $Ulockfile
1781
1782	set -- $newdirlist
1783	while [ $# -gt 0 ]; do
1784		ISUSER=$1 staffer rmdir $2
1785		shift; shift
1786	done
1787	rm -rf $TMPDIR
1788}
1789
1790cleanup_signal() {
1791    	build_ok=i
1792	# this will trigger cleanup(), above.
1793	exit 1
1794}
1795
1796trap cleanup 0
1797trap cleanup_signal 1 2 3 15
1798
1799#
1800# Generic lock file processing -- make sure that the lock file doesn't
1801# exist.  If it does, it should name the build host and PID.  If it
1802# doesn't, then make sure we can create it.  Clean up locks that are
1803# known to be stale (assumes host name is unique among build systems
1804# for the workspace).
1805#
1806create_lock() {
1807	lockf=$1
1808	lockvar=$2
1809
1810	ldir=`dirname $lockf`
1811	[ -d $ldir ] || newdir $ldir || exit 1
1812	eval $lockvar=$lockf
1813
1814	while ! staffer ln -s $hostname.$STAFFER.$$ $lockf 2> /dev/null; do
1815		basews=`basename $CODEMGR_WS`
1816		ls -l $lockf | nawk '{print $NF}' | IFS=. read host user pid
1817		if [ "$host" != "$hostname" ]; then
1818			echo "$MACH build of $basews apparently" \
1819			    "already started by $user on $host as $pid."
1820			exit 1
1821		elif kill -s 0 $pid 2>/dev/null; then
1822			echo "$MACH build of $basews already started" \
1823			    "by $user as $pid."
1824			exit 1
1825		else
1826			# stale lock; clear it out and try again
1827			rm -f $lockf
1828		fi
1829	done
1830}
1831
1832#
1833# Return the list of interesting proto areas, depending on the current
1834# options.
1835#
1836allprotos() {
1837	roots="$ROOT"
1838	if [ $O_FLAG = y ]; then
1839		# OpenSolaris deliveries require separate proto areas.
1840		[ $D_FLAG = y ] && roots="$roots $ROOT-open"
1841		[ $F_FLAG = n ] && roots="$roots $ROOT-open-nd"
1842	fi
1843	if [[ $D_FLAG = y && $F_FLAG = n ]]; then
1844		[ $MULTI_PROTO = yes ] && roots="$roots $ROOT-nd"
1845	fi
1846
1847	echo $roots
1848}
1849
1850# Ensure no other instance of this script is running on this host.
1851# LOCKNAME can be set in <env_file>, and is by default, but is not
1852# required due to the use of $ATLOG below.
1853if [ -n "$LOCKNAME" ]; then
1854	create_lock /tmp/$LOCKNAME "lockfile"
1855fi
1856#
1857# Create from one, two, or three other locks:
1858#	$ATLOG/nightly.lock
1859#		- protects against multiple builds in same workspace
1860#	$PARENT_WS/usr/src/nightly.$MACH.lock
1861#		- protects against multiple 'u' copy-backs
1862#	$NIGHTLY_PARENT_ROOT/nightly.lock
1863#		- protects against multiple 'U' copy-backs
1864#
1865# Overriding ISUSER to 1 causes the lock to be created as root if the
1866# script is run as root.  The default is to create it as $STAFFER.
1867ISUSER=1 create_lock $ATLOG/nightly.lock "atloglockfile"
1868if [ "$u_FLAG" = "y" ]; then
1869	create_lock $PARENT_WS/usr/src/nightly.$MACH.lock "ulockfile"
1870fi
1871if [ "$U_FLAG" = "y" ]; then
1872	# NIGHTLY_PARENT_ROOT is written as root if script invoked as root.
1873	ISUSER=1 create_lock $NIGHTLY_PARENT_ROOT/nightly.lock "Ulockfile"
1874fi
1875
1876# Locks have been taken, so we're doing a build and we're committed to
1877# the directories we may have created so far.
1878newdirlist=
1879
1880#
1881# Create mail_msg_file
1882#
1883mail_msg_file="${TMPDIR}/mail_msg"
1884touch $mail_msg_file
1885build_time_file="${TMPDIR}/build_time"
1886build_environ_file="${TMPDIR}/build_environ"
1887touch $build_environ_file
1888#
1889#	Move old LOGFILE aside
1890#	ATLOG directory already made by 'create_lock' above
1891#
1892if [ -f $LOGFILE ]; then
1893	mv -f $LOGFILE ${LOGFILE}-
1894fi
1895#
1896#	Build OsNet source
1897#
1898START_DATE=`date`
1899SECONDS=0
1900echo "\n==== Nightly $maketype build started:   $START_DATE ====" \
1901    | tee -a $LOGFILE > $build_time_file
1902
1903echo "\nBuild project:  $build_project\nBuild taskid:   $build_taskid" | \
1904    tee -a $mail_msg_file >> $LOGFILE
1905
1906# make sure we log only to the nightly build file
1907build_noise_file="${TMPDIR}/build_noise"
1908exec </dev/null >$build_noise_file 2>&1
1909
1910run_hook SYS_PRE_NIGHTLY
1911run_hook PRE_NIGHTLY
1912
1913echo "\n==== list of environment variables ====\n" >> $LOGFILE
1914env >> $LOGFILE
1915
1916echo "\n==== Nightly argument issues ====\n" | tee -a $mail_msg_file >> $LOGFILE
1917
1918if [ "$P_FLAG" = "y" ]; then
1919	obsolete_build GPROF | tee -a $mail_msg_file >> $LOGFILE
1920fi
1921
1922if [ "$T_FLAG" = "y" ]; then
1923	obsolete_build TRACE | tee -a $mail_msg_file >> $LOGFILE
1924fi
1925
1926if is_source_build; then
1927	if [ "$i_FLAG" = "y" -o "$i_CMD_LINE_FLAG" = "y" ]; then
1928		echo "WARNING: the -S flags do not support incremental" \
1929		    "builds; forcing clobber\n" | tee -a $mail_msg_file >> $LOGFILE
1930		i_FLAG=n
1931		i_CMD_LINE_FLAG=n
1932	fi
1933	if [ "$N_FLAG" = "n" ]; then
1934		echo "WARNING: the -S flags do not support protocmp;" \
1935		    "protocmp disabled\n" | \
1936		    tee -a $mail_msg_file >> $LOGFILE
1937		N_FLAG=y
1938	fi
1939	if [ "$l_FLAG" = "y" ]; then
1940		echo "WARNING: the -S flags do not support lint;" \
1941		    "lint disabled\n" | tee -a $mail_msg_file >> $LOGFILE
1942		l_FLAG=n
1943	fi
1944	if [ "$C_FLAG" = "y" ]; then
1945		echo "WARNING: the -S flags do not support cstyle;" \
1946		    "cstyle check disabled\n" | tee -a $mail_msg_file >> $LOGFILE
1947		C_FLAG=n
1948	fi
1949else
1950	if [ "$N_FLAG" = "y" ]; then
1951		if [ "$p_FLAG" = "y" ]; then
1952			cat <<EOF | tee -a $mail_msg_file >> $LOGFILE
1953WARNING: the p option (create packages) is set, but so is the N option (do
1954         not run protocmp); this is dangerous; you should unset the N option
1955EOF
1956		else
1957			cat <<EOF | tee -a $mail_msg_file >> $LOGFILE
1958Warning: the N option (do not run protocmp) is set; it probably shouldn't be
1959EOF
1960		fi
1961		echo "" | tee -a $mail_msg_file >> $LOGFILE
1962	fi
1963fi
1964
1965if [ "$O_FLAG" = "y" -a "$a_FLAG" = "n" ]; then
1966	echo "WARNING: OpenSolaris deliveries (-O) require archives;" \
1967	    "enabling the -a flag." | tee -a $mail_msg_file >> $LOGFILE
1968	a_FLAG=y
1969fi
1970
1971if [ "$a_FLAG" = "y" -a "$D_FLAG" = "n" -a "$F_FLAG" = "y" ]; then
1972	echo "WARNING: Neither DEBUG nor non-DEBUG build requested, but the" \
1973	    "'a' option was set." | tee -a $mail_msg_file >> $LOGFILE
1974fi
1975
1976if [ "$D_FLAG" = "n" -a "$l_FLAG" = "y" ]; then
1977	#
1978	# In the past we just complained but went ahead with the lint
1979	# pass, even though the proto area was built non-debug.  It's
1980	# unlikely that non-debug headers will make a difference, but
1981	# rather than assuming it's a safe combination, force the user
1982	# to specify a debug build.
1983	#
1984	echo "WARNING: DEBUG build not requested; disabling lint.\n" \
1985	    | tee -a $mail_msg_file >> $LOGFILE
1986	l_FLAG=n
1987fi
1988
1989if [ "$f_FLAG" = "y" ]; then
1990	if [ "$i_FLAG" = "y" ]; then
1991		echo "WARNING: the -f flag cannot be used during incremental" \
1992		    "builds; ignoring -f\n" | tee -a $mail_msg_file >> $LOGFILE
1993		f_FLAG=n
1994	fi
1995	if [ "$p_FLAG" != "y" -o "$l_FLAG" != "y" ]; then
1996		echo "WARNING: the -f flag requires -l and -p; ignoring -f\n" | \
1997		    tee -a $mail_msg_file >> $LOGFILE
1998		f_FLAG=n
1999	fi
2000fi
2001
2002if [ "$w_FLAG" = "y" -a ! -d $ROOT ]; then
2003	echo "WARNING: -w specified, but $ROOT does not exist;" \
2004	    "ignoring -w\n" | tee -a $mail_msg_file >> $LOGFILE
2005	w_FLAG=n
2006fi
2007
2008if [ "$t_FLAG" = "n" ]; then
2009	#
2010	# We're not doing a tools build, so make sure elfsign(1) is
2011	# new enough to safely sign non-crypto binaries.  We test
2012	# debugging output from elfsign to detect the old version.
2013	#
2014	newelfsigntest=`SUNW_CRYPTO_DEBUG=stderr /usr/bin/elfsign verify \
2015	    -e /usr/lib/security/pkcs11_softtoken.so.1 2>&1 \
2016	    | egrep algorithmOID`
2017	if [ -z "$newelfsigntest" ]; then
2018		echo "WARNING: /usr/bin/elfsign out of date;" \
2019		    "will only sign crypto modules\n" | \
2020		    tee -a $mail_msg_file >> $LOGFILE
2021		export ELFSIGN_OBJECT=true
2022	elif [ "$VERIFY_ELFSIGN" = "y" ]; then
2023		echo "WARNING: VERIFY_ELFSIGN=y requires" \
2024		    "the -t flag; ignoring VERIFY_ELFSIGN\n" | \
2025		    tee -a $mail_msg_file >> $LOGFILE
2026	fi
2027fi
2028
2029[ "$O_FLAG" = y ] && MULTI_PROTO=yes
2030
2031case $MULTI_PROTO in
2032yes|no)	;;
2033*)
2034	echo "WARNING: MULTI_PROTO is \"$MULTI_PROTO\"; " \
2035	    "should be \"yes\" or \"no\"." | tee -a $mail_msg_file >> $LOGFILE
2036	echo "Setting MULTI_PROTO to \"no\".\n" | \
2037	    tee -a $mail_msg_file >> $LOGFILE
2038	export MULTI_PROTO=no
2039	;;
2040esac
2041
2042echo "\n==== Build version ====\n" | tee -a $mail_msg_file >> $LOGFILE
2043echo $VERSION | tee -a $mail_msg_file >> $LOGFILE
2044
2045# Save the current proto area if we're comparing against the last build
2046if [ "$w_FLAG" = "y" -a -d "$ROOT" ]; then
2047    if [ -d "$ROOT.prev" ]; then
2048	rm -rf $ROOT.prev
2049    fi
2050    mv $ROOT $ROOT.prev
2051fi
2052
2053# Same for non-DEBUG proto area
2054if [ "$w_FLAG" = "y" -a "$MULTI_PROTO" = yes -a -d "$ROOT-nd" ]; then
2055	if [ -d "$ROOT-nd.prev" ]; then
2056		rm -rf $ROOT-nd.prev
2057	fi
2058	mv $ROOT-nd $ROOT-nd.prev
2059fi
2060
2061#
2062#	Decide whether to clobber
2063#
2064if [ "$i_FLAG" = "n" -a -d "$SRC" ]; then
2065	echo "\n==== Make clobber at `date` ====\n" >> $LOGFILE
2066
2067	cd $SRC
2068	# remove old clobber file
2069	rm -f $SRC/clobber.out
2070	rm -f $SRC/clobber-${MACH}.out
2071
2072	# Remove all .make.state* files, just in case we are restarting
2073	# the build after having interrupted a previous 'make clobber'.
2074	find . \( -name SCCS -o -name .hg -o -name .svn \
2075		-o -name 'interfaces.*' \) -prune \
2076		-o -name '.make.*' -print | xargs rm -f
2077
2078	$MAKE -ek clobber 2>&1 | tee -a $SRC/clobber-${MACH}.out >> $LOGFILE
2079	echo "\n==== Make clobber ERRORS ====\n" >> $mail_msg_file
2080	grep "$MAKE:" $SRC/clobber-${MACH}.out |
2081		egrep -v "Ignoring unknown host" \
2082		>> $mail_msg_file
2083
2084	if [[ "$t_FLAG" = "y" || "$O_FLAG" = "y" ]]; then
2085		echo "\n==== Make tools clobber at `date` ====\n" >> $LOGFILE
2086		cd ${TOOLS}
2087		rm -f ${TOOLS}/clobber-${MACH}.out
2088		$MAKE -ek clobber 2>&1 | \
2089			tee -a ${TOOLS}/clobber-${MACH}.out >> $LOGFILE
2090		echo "\n==== Make tools clobber ERRORS ====\n" \
2091			>> $mail_msg_file
2092		grep "$MAKE:" ${TOOLS}/clobber-${MACH}.out \
2093			>> $mail_msg_file
2094		rm -rf ${TOOLS_PROTO}
2095		mkdir -p ${TOOLS_PROTO}
2096	fi
2097
2098	rm -rf `allprotos`
2099
2100	# Get back to a clean workspace as much as possible to catch
2101	# problems that only occur on fresh workspaces.
2102	# Remove all .make.state* files, libraries, and .o's that may
2103	# have been omitted from clobber.  A couple of libraries are
2104	# under source code control, so leave them alone.
2105	# We should probably blow away temporary directories too.
2106	cd $SRC
2107	find $relsrcdirs \( -name SCCS -o -name .hg -o -name .svn \
2108	    -o -name 'interfaces.*' \) -prune -o \
2109	    \( -name '.make.*' -o -name 'lib*.a' -o -name 'lib*.so*' -o \
2110	       -name '*.o' \) -print | \
2111	    grep -v 'tools/ctf/dwarf/.*/libdwarf' | xargs rm -f
2112else
2113	echo "\n==== No clobber at `date` ====\n" >> $LOGFILE
2114fi
2115
2116type bringover_teamware > /dev/null 2>&1 || bringover_teamware() {
2117	# sleep on the parent workspace's lock
2118	while egrep -s write $BRINGOVER_WS/Codemgr_wsdata/locks
2119	do
2120		sleep 120
2121	done
2122
2123	if [[ -z $BRINGOVER ]]; then
2124		BRINGOVER=$TEAMWARE/bin/bringover
2125	fi
2126
2127	staffer $BRINGOVER -c "nightly update" -p $BRINGOVER_WS \
2128	    -w $CODEMGR_WS $BRINGOVER_FILES < /dev/null 2>&1 ||
2129		touch $TMPDIR/bringover_failed
2130
2131        staffer bringovercheck $CODEMGR_WS >$TMPDIR/bringovercheck.out 2>&1
2132	if [ -s $TMPDIR/bringovercheck.out ]; then
2133		echo "\n==== POST-BRINGOVER CLEANUP NOISE ====\n"
2134		cat $TMPDIR/bringovercheck.out
2135	fi
2136}
2137
2138type bringover_mercurial > /dev/null 2>&1 || bringover_mercurial() {
2139	typeset -x PATH=$PATH
2140
2141	# If the repository doesn't exist yet, then we want to populate it.
2142	# We only initially populate the closed repository if the open
2143	# repository doesn't also exist (e.g.: don't bringover closed if
2144	# only usr/src exists)
2145	if [[ ! -d $CODEMGR_WS/.hg ]]; then
2146		staffer hg init $CODEMGR_WS
2147		# If the user set CLOSED_BRINGOVER_WS, then we'll want to
2148		# initialise the closed repository
2149		if [[ -n $CLOSED_BRINGOVER_WS ]]; then
2150			staffer mkdir -p $CODEMGR_WS/usr
2151			staffer hg init $CODEMGR_WS/usr/closed
2152			CLOSED_IS_PRESENT="yes"
2153		fi
2154	fi
2155
2156	typeset -x HGMERGE="/bin/false"
2157
2158	# Do the bringover, along with an update.  If a merge is necessary,
2159	# this will not fail properly:
2160	#     http://www.selenic.com/mercurial/bts/issue186
2161	# so we grep through the output for signs of a merge.
2162	#
2163	# Note that pulling even non-conflicting changes on top of local
2164	# changes (committed or not) requires a merge.
2165	staffer hg --cwd $CODEMGR_WS pull -u $BRINGOVER_WS 2>&1 | \
2166	    tee $TMPDIR/pull_open.out
2167	hgstatus=$?
2168	if [ $hgstatus -ne 0 ]; then
2169		touch $TMPDIR/bringover_failed
2170		return
2171	fi
2172
2173	# We never want to clone usr/closed by default.  If the usr/closed
2174	# repository exists already and CLOSED_BRINGOVER_WS is set, then
2175	# we update (pull -u).
2176	if [[ -d $SRC/../closed && -n $CLOSED_BRINGOVER_WS ]]; then
2177		staffer hg --cwd $SRC/../closed pull -u \
2178			$CLOSED_BRINGOVER_WS 2>&1 |
2179			tee -a $TMPDIR/pull_closed.out
2180		hgstatus=$?
2181		if [ $hgstatus -ne 0 ]; then
2182			touch $TMPDIR/bringover_failed
2183			return
2184		fi
2185	fi
2186
2187	# If there were uncommitted changes, the pull -u would have
2188	# attempted a merge.  In the likely event that it failed, fail the
2189	# bringover.
2190	if grep "^merging.*failed" $TMPDIR/pull_open.out > /dev/null 2>&1 || \
2191		grep "^merging.*failed" $TMPDIR/pull_closed.out >/dev/null 2>&1;
2192       	then
2193		touch $TMPDIR/bringover_failed
2194		return
2195	fi
2196
2197	# If heads were added, then a merge is required.  We attempt the
2198	# merge, in case the branches touch different files (something that
2199	# teamware wouldn't balk at).  If the merge fails, fail the
2200	# bringover, leaving the conflicts unresolved.
2201	#
2202	# Note that even if the merge succeeds, the result of the merge
2203	# will need to be committed, and not doing so will block any
2204	# further pulls.
2205	if grep "not updating" $TMPDIR/pull_open.out > /dev/null 2>&1; then
2206		hg --cwd $CODEMGR_WS merge 2>&1 | tee $TMPDIR/merge.out
2207		if grep "^merging.*failed" $TMPDIR/merge.out >/dev/null 2>&1;
2208		then
2209			touch $TMPDIR/bringover_failed
2210		fi
2211	fi
2212	if grep "not updating" $TMPDIR/pull_closed.out > /dev/null 2>&1; then
2213		hg --cwd $SRC/../closed merge 2>&1 | tee $TMPDIR/merge.out
2214		if grep "^merging.*failed" $TMPDIR/merge.out >/dev/null 2>&1;
2215		then
2216			touch $TMPDIR/bringover_failed
2217		fi
2218	fi
2219}
2220
2221type bringover_subversion > /dev/null 2>&1 || bringover_subversion() {
2222	typeset -x PATH=$PATH
2223
2224	if [[ ! -d $CODEMGR_WS/.svn ]]; then
2225		staffer svn checkout $BRINGOVER_WS $CODEMGR_WS ||
2226			touch $TMPDIR/bringover_failed
2227	else
2228		typeset root
2229		root=$(staffer svn info $CODEMGR_WS |
2230			nawk '/^Repository Root:/ {print $NF}')
2231		if [[ $root != $BRINGOVER_WS ]]; then
2232			# We fail here because there's no way to update
2233			# from a named repo.
2234			cat <<-EOF
2235			\$BRINGOVER_WS doesn't match repository root:
2236			  \$BRINGOVER_WS:  $BRINGOVER_WS
2237			  Repository root: $root
2238			EOF
2239			touch $TMPDIR/bringover_failed
2240		else
2241			# If a conflict happens, svn still exits 0.
2242			staffer svn update $CODEMGR_WS | tee $TMPDIR/pull.out ||
2243				touch $TMPDIR/bringover_failed
2244			if grep "^C" $TMPDIR/pull.out > /dev/null 2>&1; then
2245				touch $TMPDIR/bringover_failed
2246			fi
2247		fi
2248	fi
2249}
2250
2251type bringover_none > /dev/null 2>&1 || bringover_none() {
2252	echo "Couldn't figure out what kind of SCM to use for $BRINGOVER_WS."
2253	touch $TMPDIR/bringover_failed
2254}
2255
2256# Parse the URL.
2257# The other way to deal with empty components is to echo a string that can
2258# be eval'ed by the caller to associate values (possibly empty) with
2259# variables.  In that case, passing in a printf string would let the caller
2260# choose the variable names.
2261parse_url() {
2262	typeset url method host port path
2263
2264	url=$1
2265	method=${url%%://*}
2266	host=${url#$method://}
2267	path=${host#*/}
2268	host=${host%%/*}
2269	if [[ $host == *:* ]]; then
2270		port=${host#*:}
2271		host=${host%:*}
2272	fi
2273
2274	# method can never be empty.  host can only be empty if method is
2275	# file, and that implies it's localhost.  path can default to / if
2276	# it's otherwise empty, leaving port as the only component without
2277	# a default, so it has to go last.
2278	echo $method ${host:-localhost} ${path:-/} $port
2279}
2280
2281http_get() {
2282	typeset url method host port path
2283
2284	url=$1
2285
2286	if [[ -n $http_proxy ]]; then
2287		parse_url $http_proxy | read method host path port
2288		echo "GET $url HTTP/1.0\r\n" |
2289			mconnect -p ${port:-8080} $host
2290	else
2291		parse_url $url | read method host path port
2292		echo "GET $path HTTP/1.0\r\n" |
2293			mconnect -p ${port:-80} $host
2294	fi
2295}
2296
2297# Echo a string name for the workspace SCM (teamware, hg, or svn).
2298function wstype {
2299	typeset rtype ltype
2300
2301	env CODEMGR_WS=$BRINGOVER_WS $WHICH_SCM 2>/dev/null | read rtype junk
2302	if [[ -z "$rtype" || "$rtype" == unknown ]]; then
2303		# Probe BRINGOVER_WS to determine its type
2304		if [[ $BRINGOVER_WS == svn*://* ]]; then
2305			rtype="subversion"
2306		elif [[ $BRINGOVER_WS == file://* ]] &&
2307		    egrep -s "This is a Subversion repository" \
2308		    ${BRINGOVER_WS#file://}/README.txt 2> /dev/null; then
2309			rtype="subversion"
2310		elif [[ $BRINGOVER_WS == ssh://* ]]; then
2311			rtype="mercurial"
2312		elif svn info $BRINGOVER_WS > /dev/null 2>&1; then
2313			rtype="subversion"
2314		elif [[ $BRINGOVER_WS == http://* ]] && \
2315		    http_get "$BRINGOVER_WS/?cmd=heads" | \
2316		    egrep -s "application/mercurial" 2> /dev/null; then
2317			rtype="mercurial"
2318		else
2319			rtype="none"
2320		fi
2321	fi
2322
2323	# Make sure that the repository is one we support.  If not, then
2324	# call it "none."
2325	case "$rtype" in
2326	none|subversion|teamware|mercurial)
2327		;;
2328	*)	rtype=none
2329		;;
2330	esac
2331
2332	# Probe CODEMGR_WS to determine its type
2333	if [[ -d $CODEMGR_WS ]]; then
2334		$WHICH_SCM | read ltype junk || exit 1
2335		# This occurs when we have an empty build directory and nightly
2336		# itself creates the directory.  It's not an error, as long as
2337		# we'll be doing a bringover.
2338		if [[ "$ltype" == unknown ]]; then
2339			ltype=$rtype
2340		fi
2341	fi
2342
2343	# If BRINGOVER_WS and CODEMGR_WS don't match, doing a bringover
2344	# will be problematic!
2345	if [[ -n $ltype && $rtype != $ltype ]]; then
2346		echo "none"
2347	else
2348		echo $rtype
2349	fi
2350}
2351
2352SCM_TYPE=$(wstype)
2353export SCM_TYPE
2354
2355#
2356#	Decide whether to bringover to the codemgr workspace
2357#
2358if [ "$n_FLAG" = "n" ]; then
2359	run_hook PRE_BRINGOVER
2360
2361	echo "\n==== bringover to $CODEMGR_WS at `date` ====\n" >> $LOGFILE
2362	echo "\n==== BRINGOVER LOG ====\n" >> $mail_msg_file
2363
2364	eval "bringover_$SCM_TYPE" 2>&1 |
2365		tee -a $mail_msg_file >> $LOGFILE
2366
2367	if [ -f $TMPDIR/bringover_failed ]; then
2368		rm -f $TMPDIR/bringover_failed
2369		build_ok=n
2370		echo "trouble with bringover, quitting at `date`." |
2371			tee -a $mail_msg_file >> $LOGFILE
2372		exit 1
2373	fi
2374
2375	run_hook POST_BRINGOVER
2376
2377	#
2378	# Possible transition from pre-split workspace to split
2379	# workspace.  See if the bringover changed anything.
2380	#
2381	CLOSED_IS_PRESENT="$orig_closed_is_present"
2382	check_closed_tree
2383else
2384	echo "\n==== No bringover to $CODEMGR_WS ====\n" >> $LOGFILE
2385fi
2386
2387echo "\n==== Build environment ====\n" | tee -a $build_environ_file >> $LOGFILE
2388
2389# System
2390whence uname | tee -a $build_environ_file >> $LOGFILE
2391uname -a 2>&1 | tee -a $build_environ_file >> $LOGFILE
2392echo | tee -a $build_environ_file >> $LOGFILE
2393
2394# nightly
2395echo "$0 $@" | tee -a $build_environ_file >> $LOGFILE
2396if [[ $nightly_path = "/opt/onbld/bin/nightly" ]] &&
2397    pkginfo SUNWonbld > /dev/null 2>&1 ; then
2398	pkginfo -l SUNWonbld | egrep "PKGINST:|VERSION:|PSTAMP:"
2399else
2400	ls -l "$nightly_path"
2401fi | tee -a $build_environ_file >> $LOGFILE
2402echo | tee -a $build_environ_file >> $LOGFILE
2403
2404# make
2405whence $MAKE | tee -a $build_environ_file >> $LOGFILE
2406$MAKE -v | tee -a $build_environ_file >> $LOGFILE
2407echo "number of concurrent jobs = $DMAKE_MAX_JOBS" |
2408    tee -a $build_environ_file >> $LOGFILE
2409
2410#
2411# Report the compiler versions.
2412#
2413
2414if [[ ! -f $SRC/Makefile ]]; then
2415	build_ok=n
2416	echo "\nUnable to find \"Makefile\" in $SRC." | \
2417	    tee -a $build_environ_file >> $LOGFILE
2418	exit 1
2419fi
2420
2421( cd $SRC
2422  for target in cc-version cc64-version java-version; do
2423	echo
2424	#
2425	# Put statefile somewhere we know we can write to rather than trip
2426	# over a read-only $srcroot.
2427	#
2428	rm -f $TMPDIR/make-state
2429	export SRC
2430	if $MAKE -K $TMPDIR/make-state -e $target 2>/dev/null; then
2431		continue
2432	fi
2433	touch $TMPDIR/nocompiler
2434  done
2435  echo
2436) | tee -a $build_environ_file >> $LOGFILE
2437
2438if [ -f $TMPDIR/nocompiler ]; then
2439	rm -f $TMPDIR/nocompiler
2440	build_ok=n
2441	echo "Aborting due to missing compiler." |
2442		tee -a $build_environ_file >> $LOGFILE
2443	exit 1
2444fi
2445
2446# as
2447whence as | tee -a $build_environ_file >> $LOGFILE
2448as -V 2>&1 | head -1 | tee -a $build_environ_file >> $LOGFILE
2449echo | tee -a $build_environ_file >> $LOGFILE
2450
2451# Check that we're running a capable link-editor
2452whence ld | tee -a $build_environ_file >> $LOGFILE
2453LDVER=`ld -V 2>&1`
2454echo $LDVER | tee -a $build_environ_file >> $LOGFILE
2455LDVER=`echo $LDVER | sed -e "s/.*-1\.//" -e "s/:.*//"`
2456if [ `expr $LDVER \< 422` -eq 1 ]; then
2457	echo "The link-editor needs to be at version 422 or higher to build" | \
2458	    tee -a $build_environ_file >> $LOGFILE
2459	echo "the latest stuff.  Hope your build works." | \
2460	    tee -a $build_environ_file >> $LOGFILE
2461fi
2462
2463#
2464# Build and use the workspace's tools if requested
2465#
2466if [[ "$t_FLAG" = "y" || "$O_FLAG" = y ]]; then
2467	set_non_debug_build_flags
2468
2469	build_tools ${TOOLS_PROTO}
2470
2471	if [[ $? -ne 0 && "$t_FLAG" = y ]]; then
2472		use_tools $TOOLS_PROTO
2473		export ONBLD_TOOLS=${ONBLD_TOOLS:=${TOOLS_PROTO}/opt/onbld}
2474	fi
2475fi
2476
2477#
2478# copy ihv proto area in addition to the build itself
2479#
2480if [ "$X_FLAG" = "y" ]; then
2481	copy_ihv_proto
2482fi
2483
2484if [ "$i_FLAG" = "y" -a "$SH_FLAG" = "y" ]; then
2485	echo "\n==== NOT Building base OS-Net source ====\n" | \
2486	    tee -a $LOGFILE >> $mail_msg_file
2487else
2488	# timestamp the start of the normal build; the findunref tool uses it.
2489	touch $SRC/.build.tstamp
2490
2491	normal_build
2492fi
2493
2494#
2495# Generate the THIRDPARTYLICENSE files if needed.  This is done before
2496# findunref to help identify license files that need to be added to
2497# the list.
2498#
2499if [ "$O_FLAG" = y -a "$build_ok" = y ]; then
2500	echo "\n==== Generating THIRDPARTYLICENSE files ====\n" | \
2501	    tee -a $mail_msg_file >> $LOGFILE
2502
2503	mktpl usr/src/tools/opensolaris/license-list >>$LOGFILE 2>&1
2504	if (( $? != 0 )) ; then
2505		echo "Couldn't create THIRDPARTYLICENSE files" |
2506		    tee -a $mail_msg_file >> $LOGFILE
2507	fi
2508fi
2509
2510#
2511# If OpenSolaris deliverables were requested, do the open-only build
2512# now, so that it happens at roughly the same point as the source
2513# product builds.  This lets us take advantage of checks that come
2514# later (e.g., the core file check).
2515#
2516if [ "$O_FLAG" = y -a "$build_ok" = y ]; then
2517	#
2518	# Generate skeleton (minimal) closed binaries for open-only
2519	# build.  There's no need to distinguish debug from non-debug
2520	# binaries, but it simplifies file management to have separate
2521	# trees.
2522	#
2523
2524	echo "\n==== Generating skeleton closed binaries for" \
2525	    "open-only build ====\n" | \
2526	    tee -a $LOGFILE >> $mail_msg_file
2527
2528	rm -rf $CODEMGR_WS/closed.skel
2529	if [ "$D_FLAG" = y ]; then
2530		mkclosed $MACH $ROOT $CODEMGR_WS/closed.skel/root_$MACH \
2531		    >>$LOGFILE 2>&1
2532		if (( $? != 0 )) ; then
2533			echo "Couldn't create skeleton DEBUG closed binaries." |
2534			    tee -a $mail_msg_file >> $LOGFILE
2535		fi
2536	fi
2537	if [ "$F_FLAG" = n ]; then
2538		mkclosed $MACH $ROOT-nd $CODEMGR_WS/closed.skel/root_$MACH-nd \
2539		    >>$LOGFILE 2>&1
2540		if (( $? != 0 )) ; then
2541			echo "Couldn't create skeleton non-DEBUG closed binaries." |
2542			    tee -a $mail_msg_file >> $LOGFILE
2543		fi
2544	fi
2545
2546	ORIG_CLOSED_IS_PRESENT=$CLOSED_IS_PRESENT
2547	export CLOSED_IS_PRESENT=no
2548
2549	ORIG_ON_CLOSED_BINS="$ON_CLOSED_BINS"
2550	export ON_CLOSED_BINS=$CODEMGR_WS/closed.skel
2551
2552	normal_build -O
2553
2554	ON_CLOSED_BINS=$ORIG_ON_CLOSED_BINS
2555	CLOSED_IS_PRESENT=$ORIG_CLOSED_IS_PRESENT
2556fi
2557
2558ORIG_SRC=$SRC
2559BINARCHIVE=${CODEMGR_WS}/bin-${MACH}.cpio.Z
2560
2561if [ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o "$SH_FLAG" = "y" ]; then
2562	save_binaries
2563fi
2564
2565
2566# EXPORT_SRC comes after CRYPT_SRC since a domestic build will need
2567# $SRC pointing to the export_source usr/src.
2568
2569if [ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o "$SH_FLAG" = "y" ]; then
2570	if [ "$SD_FLAG" = "y" -a $build_ok = y ]; then
2571	    set_up_source_build ${CODEMGR_WS} ${CRYPT_SRC} CRYPT_SRC
2572	fi
2573
2574	if [ $build_ok = y ]; then
2575	    set_up_source_build ${CODEMGR_WS} ${EXPORT_SRC} EXPORT_SRC
2576	fi
2577fi
2578
2579if [ "$SD_FLAG" = "y" -a $build_ok = y ]; then
2580	# drop the crypt files in place.
2581	cd ${EXPORT_SRC}
2582	echo "\nextracting crypt_files.cpio.Z onto export_source.\n" \
2583	    >> ${LOGFILE}
2584	zcat ${CODEMGR_WS}/crypt_files.cpio.Z | \
2585	    cpio -idmucvB 2>/dev/null >> ${LOGFILE}
2586	if [ "$?" = "0" ]; then
2587		echo "\n==== DOMESTIC extraction succeeded ====\n" \
2588		    >> $mail_msg_file
2589	else
2590		echo "\n==== DOMESTIC extraction failed ====\n" \
2591		    >> $mail_msg_file
2592	fi
2593
2594fi
2595
2596if [ "$SO_FLAG" = "y" -a $build_ok = y ]; then
2597	#
2598	# Copy the open sources into their own tree, set up the closed
2599	# binaries, and set up the environment.  The build looks for
2600	# the closed binaries in a location that depends on whether
2601	# it's a DEBUG build, so we might need to make two copies.
2602	#
2603	# If copy_source fails, it will have already generated an
2604	# error message and set build_ok=n, so we don't need to worry
2605	# about that here.
2606	#
2607	copy_source $CODEMGR_WS $OPEN_SRCDIR OPEN_SOURCE usr/src
2608fi
2609
2610if [ "$SO_FLAG" = "y" -a $build_ok = y ]; then
2611	SRC=$OPEN_SRCDIR/usr/src
2612
2613	# Try not to clobber any user-provided closed binaries.
2614	export ON_CLOSED_BINS=$CODEMGR_WS/closed$$
2615
2616	echo "\n==== Copying skeleton closed binaries to" \
2617	    "$ON_CLOSED_BINS ====\n" | \
2618	    tee -a $mail_msg_file >> $LOGFILE
2619
2620	if [ "$D_FLAG" = y ]; then
2621		mkclosed $MACH $ROOT $ON_CLOSED_BINS/root_$MACH >>$LOGFILE 2>&1
2622		if (( $? != 0 )) ; then
2623			build_ok=n
2624			echo "Couldn't create DEBUG closed binaries." |
2625			    tee -a $mail_msg_file >> $LOGFILE
2626		fi
2627	fi
2628	if [ "$F_FLAG" = n ]; then
2629		root=$ROOT
2630		[ "$MULTI_PROTO" = yes ] && root=$ROOT-nd
2631		mkclosed $MACH $root $ON_CLOSED_BINS/root_$MACH-nd \
2632		    >>$LOGFILE 2>&1
2633		if (( $? != 0 )) ; then
2634			build_ok=n
2635			echo "Couldn't create non-DEBUG closed binaries." |
2636			    tee -a $mail_msg_file >> $LOGFILE
2637		fi
2638	fi
2639
2640	export CLOSED_IS_PRESENT=no
2641fi
2642
2643if is_source_build && [ $build_ok = y ] ; then
2644	# remove proto area(s) here, since we don't clobber
2645	rm -rf `allprotos`
2646	if [ "$t_FLAG" = "y" ]; then
2647		set_non_debug_build_flags
2648		ORIG_TOOLS=$TOOLS
2649		#
2650		# SRC was set earlier to point to the source build
2651		# source tree (e.g., $EXPORT_SRC).
2652		#
2653		TOOLS=${SRC}/tools
2654		build_tools ${SRC}/tools/proto
2655		TOOLS=$ORIG_TOOLS
2656	fi
2657
2658	export EXPORT_RELEASE_BUILD ; EXPORT_RELEASE_BUILD=#
2659	normal_build
2660fi
2661
2662if [[ "$SO_FLAG" = "y" && "$build_ok" = "y" ]]; then
2663	rm -rf $ON_CLOSED_BINS
2664fi
2665
2666#
2667# There are several checks that need to look at the proto area, but
2668# they only need to look at one, and they don't care whether it's
2669# DEBUG or non-DEBUG.
2670#
2671if [[ "$MULTI_PROTO" = yes && "$D_FLAG" = n ]]; then
2672	checkroot=$ROOT-nd
2673else
2674	checkroot=$ROOT
2675fi
2676
2677if [ "$build_ok" = "y" ]; then
2678	echo "\n==== Creating protolist system file at `date` ====" \
2679		>> $LOGFILE
2680	protolist $checkroot > $ATLOG/proto_list_${MACH}
2681	echo "==== protolist system file created at `date` ====\n" \
2682		>> $LOGFILE
2683
2684	if [ "$N_FLAG" != "y" ]; then
2685		echo "\n==== Impact on packages ====\n" >> $mail_msg_file
2686
2687		# If there is a reference proto list, compare the build's proto
2688		# list with the reference to see changes in proto areas.
2689		# Use the current exception list.
2690		exc=etc/exception_list_$MACH
2691		if [ -f $SRC/pkgdefs/$exc ]; then
2692			ELIST="-e $SRC/pkgdefs/$exc"
2693		fi
2694		if [ "$X_FLAG" = "y" -a -f $IA32_IHV_WS/usr/src/pkgdefs/$exc ]; then
2695			ELIST="$ELIST -e $IA32_IHV_WS/usr/src/pkgdefs/$exc"
2696		fi
2697
2698		if [ -f "$REF_PROTO_LIST" ]; then
2699			# For builds that copy the IHV proto area (-X), add the
2700			# IHV proto list to the reference list if the reference
2701			# was built without -X.
2702			#
2703			# For builds that don't copy the IHV proto area, add the
2704			# IHV proto list to the build's proto list if the
2705			# reference was built with -X.
2706			#
2707			# Use the presence of the first file entry of the cached
2708			# IHV proto list in the reference list to determine
2709			# whether it was build with -X or not.
2710			IHV_REF_PROTO_LIST=$SRC/pkgdefs/etc/proto_list_ihv_$MACH
2711			grepfor=$(nawk '$1 == "f" { print $2; exit }' \
2712				$IHV_REF_PROTO_LIST 2> /dev/null)
2713			if [ $? = 0 -a -n "$grepfor" ]; then
2714				if [ "$X_FLAG" = "y" ]; then
2715					grep -w "$grepfor" \
2716						$REF_PROTO_LIST > /dev/null
2717					if [ ! "$?" = "0" ]; then
2718						REF_IHV_PROTO="-d $IHV_REF_PROTO_LIST"
2719					fi
2720				else
2721					grep -w "$grepfor" \
2722						$REF_PROTO_LIST > /dev/null
2723					if [ "$?" = "0" ]; then
2724						IHV_PROTO_LIST="$IHV_REF_PROTO_LIST"
2725					fi
2726				fi
2727			fi
2728
2729			$PROTOCMPTERSE \
2730			  "Files in yesterday's proto area, but not today's:" \
2731			  "Files in today's proto area, but not yesterday's:" \
2732			  "Files that changed between yesterday and today:" \
2733			  ${ELIST} \
2734			  -d $REF_PROTO_LIST \
2735			  $REF_IHV_PROTO \
2736			  $ATLOG/proto_list_${MACH} \
2737			  $IHV_PROTO_LIST \
2738				>> $mail_msg_file
2739		fi
2740		# Compare the build's proto list with current package
2741		# definitions to audit the quality of package definitions
2742		# and makefile install targets. Use the current exception list.
2743		PKGDEFS_LIST=""
2744		for d in $abssrcdirs; do
2745			if [ -d $d/pkgdefs ]; then
2746				PKGDEFS_LIST="$PKGDEFS_LIST -d $d/pkgdefs"
2747			fi
2748		done
2749		if [ "$X_FLAG" = "y" -a -d $IA32_IHV_WS/usr/src/pkgdefs ]; then
2750			PKGDEFS_LIST="$PKGDEFS_LIST -d $IA32_IHV_WS/usr/src/pkgdefs"
2751		fi
2752
2753		$PROTOCMPTERSE \
2754		    "Files missing from the proto area:" \
2755		    "Files missing from packages:" \
2756		    "Inconsistencies between pkgdefs and proto area:" \
2757		    ${ELIST} \
2758		    ${PKGDEFS_LIST} \
2759		    $ATLOG/proto_list_${MACH} \
2760		    >> $mail_msg_file
2761	fi
2762fi
2763
2764if [ "$u_FLAG" = "y"  -a "$build_ok" = "y" ]; then
2765	staffer cp $ATLOG/proto_list_${MACH} \
2766		$PARENT_WS/usr/src/proto_list_${MACH}
2767fi
2768
2769# Update parent proto area if necessary. This is done now
2770# so that the proto area has either DEBUG or non-DEBUG kernels.
2771# Note that this clears out the lock file, so we can dispense with
2772# the variable now.
2773if [ "$U_FLAG" = "y" -a "$build_ok" = "y" ]; then
2774	echo "\n==== Copying proto area to $NIGHTLY_PARENT_ROOT ====\n" | \
2775	    tee -a $LOGFILE >> $mail_msg_file
2776	# The rm -rf command below produces predictable errors if
2777	# nightly is invoked from the parent's $ROOT/opt/onbld/bin,
2778	# and that directory is accessed via NFS.  This is because
2779	# deleted-but-still-open files don't actually disappear as
2780	# expected, but rather turn into .nfsXXXX junk files, leaving
2781	# the directory non-empty.  Since this is a not-unusual usage
2782	# pattern, and we still want to catch other errors here, we
2783	# take the unusal step of moving aside 'nightly' from that
2784	# directory (if we're using it).
2785	mypath=${nightly_path##*/root_$MACH/}
2786	if [ "$mypath" = $nightly_path ]; then
2787		mypath=opt/onbld/bin/${nightly_path##*/}
2788	fi
2789	if [ $nightly_path -ef $PARENT_WS/proto/root_$MACH/$mypath ]; then
2790		mv -f $nightly_path $PARENT_WS/proto/root_$MACH
2791	fi
2792	rm -rf $PARENT_WS/proto/root_$MACH/*
2793	unset Ulockfile
2794	mkdir -p $NIGHTLY_PARENT_ROOT
2795	if [[ "$MULTI_PROTO" = no || "$D_FLAG" = y ]]; then
2796		cd $ROOT
2797		( tar cf - . |
2798		    ( cd $NIGHTLY_PARENT_ROOT;  umask 0; tar xpf - ) ) 2>&1 |
2799		    tee -a $mail_msg_file >> $LOGFILE
2800	fi
2801	if [[ "$MULTI_PROTO" = yes && "$F_FLAG" = n ]]; then
2802		mkdir -p $NIGHTLY_PARENT_ROOT-nd
2803		cd $ROOT-nd
2804		( tar cf - . |
2805		    ( cd $NIGHTLY_PARENT_ROOT-nd; umask 0; tar xpf - ) ) 2>&1 |
2806		    tee -a $mail_msg_file >> $LOGFILE
2807	fi
2808fi
2809
2810#
2811# do shared library interface verification
2812#
2813
2814if [ "$A_FLAG" = "y" -a "$build_ok" = "y" ]; then
2815	echo "\n==== Check versioning and ABI information ====\n"  | \
2816	    tee -a $LOGFILE >> $mail_msg_file
2817
2818	rm -rf $SRC/interfaces.ref
2819	if [ -d $SRC/interfaces.out ]; then
2820		mv $SRC/interfaces.out $SRC/interfaces.ref
2821	fi
2822	rm -rf $SRC/interfaces.out
2823	mkdir -p $SRC/interfaces.out
2824
2825	intf_check -V -m -o -b $SRC/tools/abi/etc \
2826		-d $SRC/interfaces.out $checkroot 2>&1 | sort \
2827		> $SRC/interfaces.out/log
2828
2829	# report any ERROR found in log file
2830	fgrep 'ERROR' $SRC/interfaces.out/log | sed 's/^ERROR: //' | \
2831		tee -a $LOGFILE >> $mail_msg_file
2832
2833	if [ ! -d $SRC/interfaces.ref ] ; then
2834		mkdir -p $SRC/interfaces.ref
2835		if [ -d  $SRC/interfaces.out ]; then
2836			cp -r $SRC/interfaces.out/* $SRC/interfaces.ref
2837		fi
2838	fi
2839
2840	echo "\n==== Diff versioning warnings (since last build) ====\n" | \
2841	    tee -a $LOGFILE >> $mail_msg_file
2842
2843	out_vers=`grep ^VERSION $SRC/interfaces.out/log`;
2844	ref_vers=`grep ^VERSION $SRC/interfaces.ref/log`;
2845
2846	# Report any differences in WARNING messages between last
2847	# and current build.
2848	if [ "$out_vers" = "$ref_vers" ]; then
2849		diff $SRC/interfaces.ref/log $SRC/interfaces.out/log | \
2850		    fgrep 'WARNING' | sed 's/WARNING: //' | \
2851		    tee -a $LOGFILE >> $mail_msg_file
2852	fi
2853fi
2854
2855if [ "$r_FLAG" = "y" -a "$build_ok" = "y" ]; then
2856	echo "\n==== Check ELF runtime attributes ====\n" | \
2857	    tee -a $LOGFILE >> $mail_msg_file
2858
2859	LDDUSAGE="^ldd: does not support -e"
2860	LDDWRONG="wrong class"
2861	CRLERROR="^crle:"
2862	CRLECONF="^crle: configuration file:"
2863
2864	RUNTIMEREF=$SRC/runtime-${MACH}.ref
2865	RUNTIMEOUT=$SRC/runtime-${MACH}.out
2866
2867	rm -f $RUNTIMEREF
2868	if [ -f $RUNTIMEOUT ]; then
2869		egrep -v "$LDDUSAGE|$LDDWRONG|$CRLERROR|$CRLECONF" \
2870			$RUNTIMEOUT > $RUNTIMEREF
2871	fi
2872
2873	# If we're doing a debug build the proto area will be left with
2874	# debuggable objects, thus don't assert -s.
2875	if [ "$D_FLAG" = "y" ]; then
2876		rtime_sflag=""
2877	else
2878		rtime_sflag="-s"
2879	fi
2880	check_rtime -d $checkroot -i -m -o $rtime_sflag $checkroot 2>&1 | \
2881	    egrep -v ": unreferenced object=$checkroot/.*/lib(w|intl|thread|pthread).so" | \
2882	    egrep -v ": unused object=$checkroot/.*/lib(w|intl|thread|pthread).so" | \
2883	    sort > $RUNTIMEOUT
2884
2885	# Determine any processing errors that will affect the final output
2886	# and display these first.
2887	grep -l "$LDDUSAGE" $RUNTIMEOUT > /dev/null
2888	if (( $? == 0 )) ; then
2889	    echo "WARNING: ldd(1) does not support -e.  The version of ldd(1)" | \
2890		tee -a $LOGFILE >> $mail_msg_file
2891	    echo "on your system is old - 4390308 (s81_30) is required.\n" | \
2892		tee -a $LOGFILE >> $mail_msg_file
2893	fi
2894	grep -l "$LDDWRONG" $RUNTIMEOUT > /dev/null
2895	if (( $? == 0 )) ; then
2896	    echo "WARNING: wrong class message detected.  ldd(1) was unable" | \
2897		tee -a $LOGFILE >> $mail_msg_file
2898	    echo "to execute an object, thus it could not be checked fully." | \
2899		tee -a $LOGFILE >> $mail_msg_file
2900	    echo "Perhaps a 64-bit object was encountered on a 32-bit system," | \
2901		tee -a $LOGFILE >> $mail_msg_file
2902	    echo "or an i386 object was encountered on a sparc system?\n" | \
2903		tee -a $LOGFILE >> $mail_msg_file
2904	fi
2905	grep -l "$CRLECONF" $RUNTIMEOUT > /dev/null
2906	if (( $? == 0 )) ; then
2907	    echo "WARNING: creation of an alternative dependency cache failed." | \
2908		tee -a $LOGFILE >> $mail_msg_file
2909	    echo "Dependencies will bind to the base system libraries.\n" | \
2910		tee -a $LOGFILE >> $mail_msg_file
2911	    grep "$CRLECONF" $RUNTIMEOUT | \
2912		tee -a $LOGFILE >> $mail_msg_file
2913	    grep "$CRLERROR" $RUNTIMEOUT | grep -v "$CRLECONF" | \
2914		tee -a $LOGFILE >> $mail_msg_file
2915	    echo "\n" | tee -a $LOGFILE >> $mail_msg_file
2916	fi
2917
2918	egrep '<dependency no longer necessary>' $RUNTIMEOUT | \
2919	    tee -a $LOGFILE >> $mail_msg_file
2920
2921	# NEEDED= and RPATH= are informational; report anything else that we
2922	# haven't already.
2923	egrep -v "NEEDED=|RPATH=|$LDDUSAGE|$LDDWRONG|$CRLERROR|$CRLECONF" \
2924	    $RUNTIMEOUT | tee -a $LOGFILE >> $mail_msg_file
2925
2926	# probably should compare against a 'known ok runpaths' list
2927	if [ ! -f $RUNTIMEREF ]; then
2928		egrep -v "$LDDUSAGE|$LDDWRONG|$CRLERROR|$CRLECONF" \
2929			$RUNTIMEOUT >  $RUNTIMEREF
2930	fi
2931
2932	echo "\n==== Diff ELF runtime attributes (since last build) ====\n" \
2933	    >> $mail_msg_file
2934
2935	egrep -v "$LDDUSAGE|$LDDWRONG|$CRLERROR|$CRLECONF" $RUNTIMEOUT | \
2936	    diff $RUNTIMEREF - >> $mail_msg_file
2937fi
2938
2939# DEBUG lint of kernel begins
2940
2941if [ "$i_CMD_LINE_FLAG" = "n" -a "$l_FLAG" = "y" ]; then
2942	if [ "$LINTDIRS" = "" ]; then
2943		# LINTDIRS="$SRC/uts y $SRC/stand y $SRC/psm y"
2944		LINTDIRS="$SRC y"
2945	fi
2946	set $LINTDIRS
2947	while [ $# -gt 0 ]; do
2948		dolint $1 $2; shift; shift
2949	done
2950else
2951	echo "\n==== No '$MAKE lint' ====\n" >> $LOGFILE
2952fi
2953
2954# "make check" begins
2955
2956if [ "$i_CMD_LINE_FLAG" = "n" -a "$C_FLAG" = "y" ]; then
2957	# remove old check.out
2958	rm -f $SRC/check.out
2959
2960	rm -f $SRC/check-${MACH}.out
2961	cd $SRC
2962	$MAKE -ek check 2>&1 | tee -a $SRC/check-${MACH}.out >> $LOGFILE
2963	echo "\n==== cstyle/hdrchk errors ====\n" >> $mail_msg_file
2964
2965	grep ":" $SRC/check-${MACH}.out |
2966		egrep -v "Ignoring unknown host" | \
2967		sort | uniq >> $mail_msg_file
2968else
2969	echo "\n==== No '$MAKE check' ====\n" >> $LOGFILE
2970fi
2971
2972echo "\n==== Find core files ====\n" | \
2973    tee -a $LOGFILE >> $mail_msg_file
2974
2975find $abssrcdirs -name core -a -type f -exec file {} \; | \
2976	tee -a $LOGFILE >> $mail_msg_file
2977
2978if [ "$f_FLAG" = "y" -a "$build_ok" = "y" ]; then
2979	echo "\n==== Diff unreferenced files (since last build) ====\n" \
2980	    | tee -a $LOGFILE >>$mail_msg_file
2981	rm -f $SRC/unref-${MACH}.ref
2982	if [ -f $SRC/unref-${MACH}.out ]; then
2983		mv $SRC/unref-${MACH}.out $SRC/unref-${MACH}.ref
2984	fi
2985
2986	#
2987	# For any SCM other than teamware, we want to disable the
2988	# managed-by-SCCS test in findunref
2989	#
2990	findunref_all=""
2991	if [ "$SCM_TYPE" != teamware ]; then
2992		findunref_all="-a"
2993	fi
2994
2995	findunref $findunref_all -t $SRC/.build.tstamp $SRC/.. \
2996	    ${TOOLS}/findunref/exception_list 2>> $mail_msg_file | \
2997	    sort | sed -e s=^./src/=./= -e s=^./closed/=../closed/= \
2998	    > $SRC/unref-${MACH}.out
2999
3000	if [ ! -f $SRC/unref-${MACH}.ref ]; then
3001		cp $SRC/unref-${MACH}.out $SRC/unref-${MACH}.ref
3002	fi
3003
3004	diff $SRC/unref-${MACH}.ref $SRC/unref-${MACH}.out >>$mail_msg_file
3005fi
3006
3007#
3008# Generate the OpenSolaris deliverables if requested.  Some of these
3009# steps need to come after findunref and are commented below.
3010#
3011if [ "$O_FLAG" = y -a "$build_ok" = y ]; then
3012	echo "\n==== Generating OpenSolaris tarballs ====\n" | \
3013	    tee -a $mail_msg_file >> $LOGFILE
3014
3015	cd $CODEMGR_WS
3016
3017	#
3018	# This step grovels through the pkgdefs proto* files, so it
3019	# must come after findunref.
3020	#
3021	echo "Generating closed binaries tarball(s)..." >> $LOGFILE
3022	closed_basename=on-closed-bins
3023	if [ "$D_FLAG" = y ]; then
3024		bindrop "$ROOT" "$ROOT-open" "$closed_basename" \
3025		    >>"$LOGFILE" 2>&1
3026		if (( $? != 0 )) ; then
3027			echo "Couldn't create DEBUG closed binaries." |
3028			    tee -a $mail_msg_file >> $LOGFILE
3029		fi
3030	fi
3031	if [ "$F_FLAG" = n ]; then
3032		bindrop -n "$ROOT-nd" "$ROOT-open-nd" "$closed_basename-nd" \
3033		    >>"$LOGFILE" 2>&1
3034		if (( $? != 0 )) ; then
3035			echo "Couldn't create non-DEBUG closed binaries." |
3036			    tee -a $mail_msg_file >> $LOGFILE
3037		fi
3038	fi
3039
3040	echo "Generating SUNWonbld tarball..." >> $LOGFILE
3041	PKGARCHIVE=$PKGARCHIVE_ORIG
3042	onblddrop >> $LOGFILE 2>&1
3043	if (( $? != 0 )) ; then
3044		echo "Couldn't create SUNWonbld tarball." |
3045		    tee -a $mail_msg_file >> $LOGFILE
3046	fi
3047
3048	echo "Generating README.opensolaris..." >> $LOGFILE
3049	cat $SRC/tools/opensolaris/README.opensolaris.tmpl | \
3050	    mkreadme_osol $CODEMGR_WS/README.opensolaris >> $LOGFILE 2>&1
3051	if (( $? != 0 )) ; then
3052		echo "Couldn't create README.opensolaris." |
3053		    tee -a $mail_msg_file >> $LOGFILE
3054	fi
3055
3056	# This step walks the source tree, so it must come after
3057	# findunref.  It depends on README.opensolaris.
3058	echo "Generating source tarball..." >> $LOGFILE
3059	sdrop >>$LOGFILE 2>&1
3060	if (( $? != 0 )) ; then
3061		echo "Couldn't create source tarball." |
3062		    tee -a "$mail_msg_file" >> "$LOGFILE"
3063	fi
3064
3065	# This step depends on the closed binaries tarballs.
3066	echo "Generating BFU tarball(s)..." >> $LOGFILE
3067	if [ "$D_FLAG" = y ]; then
3068		makebfu_filt bfudrop "$ROOT-open" \
3069		    "$closed_basename.$MACH.tar.bz2" nightly-osol
3070		if (( $? != 0 )) ; then
3071			echo "Couldn't create DEBUG archives tarball." |
3072			    tee -a $mail_msg_file >> $LOGFILE
3073		fi
3074	fi
3075	if [ "$F_FLAG" = n ]; then
3076		makebfu_filt bfudrop -n "$ROOT-open-nd" \
3077		    "$closed_basename-nd.$MACH.tar.bz2" nightly-osol-nd
3078		if (( $? != 0 )) ; then
3079			echo "Couldn't create non-DEBUG archives tarball." |
3080			    tee -a $mail_msg_file >> $LOGFILE
3081		fi
3082	fi
3083fi
3084
3085# Verify that the usual lists of files, such as exception lists,
3086# contain only valid references to files.  If the build has failed,
3087# then don't check the proto area.
3088CHECK_PATHS=${CHECK_PATHS:-y}
3089if [ "$CHECK_PATHS" = y -a "$N_FLAG" != y ]; then
3090	echo "\n==== Check lists of files ====\n" | tee -a $LOGFILE \
3091		>>$mail_msg_file
3092	arg=-b
3093	[ "$build_ok" = y ] && arg=
3094	checkpaths $arg $checkroot 2>&1 | tee -a $LOGFILE >>$mail_msg_file
3095fi
3096
3097if [ "$M_FLAG" != "y" -a "$build_ok" = y ]; then
3098	echo "\n==== Impact on file permissions ====\n" \
3099		>> $mail_msg_file
3100	#
3101	# Get pkginfo files from usr/src/pkgdefs
3102	#
3103	pmodes -qvdP \
3104	`for d in $abssrcdirs; do
3105		if [ -d "$d/pkgdefs" ]
3106		then
3107			find $d/pkgdefs -name pkginfo.tmpl -print -o -name .del\* -prune
3108		fi
3109	 done | sed -e 's:/pkginfo.tmpl$::' | sort -u ` >> $mail_msg_file
3110fi
3111
3112if [ "$w_FLAG" = "y" -a "$build_ok" = "y" ]; then
3113	if [[ "$MULTI_PROTO" = no || "$D_FLAG" = y ]]; then
3114		do_wsdiff DEBUG $ROOT.prev $ROOT
3115	fi
3116
3117	if [[ "$MULTI_PROTO" = yes && "$F_FLAG" = n ]]; then
3118		do_wsdiff non-DEBUG $ROOT-nd.prev $ROOT-nd
3119	fi
3120fi
3121
3122END_DATE=`date`
3123echo "==== Nightly $maketype build completed: $END_DATE ====" | \
3124    tee -a $LOGFILE >> $build_time_file
3125
3126typeset -Z2 minutes
3127typeset -Z2 seconds
3128
3129elapsed_time=$SECONDS
3130((hours = elapsed_time / 3600 ))
3131((minutes = elapsed_time / 60  % 60))
3132((seconds = elapsed_time % 60))
3133
3134echo "\n==== Total build time ====" | \
3135    tee -a $LOGFILE >> $build_time_file
3136echo "\nreal    ${hours}:${minutes}:${seconds}" | \
3137    tee -a $LOGFILE >> $build_time_file
3138
3139if [ "$u_FLAG" = "y" -a "$f_FLAG" = "y" -a "$build_ok" = "y" ]; then
3140	staffer cp ${SRC}/unref-${MACH}.out $PARENT_WS/usr/src/
3141
3142	#
3143	# Produce a master list of unreferenced files -- ideally, we'd
3144	# generate the master just once after all of the nightlies
3145	# have finished, but there's no simple way to know when that
3146	# will be.  Instead, we assume that we're the last nightly to
3147	# finish and merge all of the unref-${MACH}.out files in
3148	# $PARENT_WS/usr/src/.  If we are in fact the final ${MACH} to
3149	# finish, then this file will be the authoritative master
3150	# list.  Otherwise, another ${MACH}'s nightly will eventually
3151	# overwrite ours with its own master, but in the meantime our
3152	# temporary "master" will be no worse than any older master
3153	# which was already on the parent.
3154	#
3155
3156	set -- $PARENT_WS/usr/src/unref-*.out
3157	cp "$1" ${TMPDIR}/unref.merge
3158	shift
3159
3160	for unreffile; do
3161		comm -12 ${TMPDIR}/unref.merge "$unreffile" > ${TMPDIR}/unref.$$
3162		mv ${TMPDIR}/unref.$$ ${TMPDIR}/unref.merge
3163	done
3164
3165	staffer cp ${TMPDIR}/unref.merge $PARENT_WS/usr/src/unrefmaster.out
3166fi
3167
3168#
3169# All done save for the sweeping up.
3170# (whichever exit we hit here will trigger the "cleanup" trap which
3171# optionally sends mail on completion).
3172#
3173if [ "$build_ok" = "y" ]; then
3174	exit 0
3175fi
3176exit 1
3177